clear
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Read in Data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

num = xlsread('moviedata_form.xlsx');

numobs = length(num);

year = num(:,1);
week = num(:,2);
month = num(:,10);

gross = num(:,4);
netweeksout = num(:,6);
netweeksout_sqr = num(:,20);
budget = num(:,5);
ticketprice = num(:,8);
population = num(:,7)*1000000;

ms = num(:,9);
ms_oo = num(:,16);

logitterm = num(:,18);
logmsdiff = num(:,17);

log_budget = num(:,19);

distributor = num(:,21);
distributorshort = num(:,22);
highbudget = num(:,13);
medbudget = num(:,14);
lowbudget = num(:,15);
titlecode = num(:,23);

eps = num(:,24);
yhat = num(:,25);
theta = num(:,26);

nqrevenue = num(:,12);
nqsubscribers = num(:,11);

budgettype = 1*lowbudget+2*medbudget+3*highbudget;

year_ind = zeros(numobs,10);
week_ind = zeros(numobs,56);
dist_ind = zeros(numobs,7);
for i=1:numobs
   year_ind(i,year(i)-2008)=1;
   week_ind(i,week(i))=1;
   dist_ind(i,distributorshort(i))=1;
end

market_delim = zeros(1,2);
market = zeros(numobs,1);
market(1)=1;
market_delim(1,1)=1;
tempw = 1;
year_delim = zeros(10,2);
tempy = 1;
year_delim(1,1)=1;
year_delim2 = zeros(10,2);
year_delim2(1,1)=1;
marketid = zeros(10,3);
marketid(1,1) = year(1);
marketid(1,2) = week(1);
marketid(1,3) = month(1);
mnqsubscribers = zeros(10,1);
mnqsubscribers(1) = nqsubscribers(1);
for i=2:numobs
    if(week(i)~=week(i-1))
       market_delim(tempw,2)=(i-1);
       tempw=tempw+1;
       market_delim(tempw,1)=i;
       marketid(tempw,1) = year(i);
       marketid(tempw,2) = week(i);
       marketid(tempw,3) = month(i);
       mnqsubscribers(tempw) = nqsubscribers(i);
       if(year(i)~=year(i-1))
          year_delim(tempy,2) = i-1;
          year_delim2(tempy,2) = tempw-1;
          tempy = tempy+1;
          year_delim(tempy,1) = i;
          year_delim2(tempy,1) = tempw;
       end
    end
    market(i) = tempw;
end
market_delim(tempw,2)=numobs;
year_delim(tempy,2) = numobs;
year_delim2(tempy,2) = tempw;
numm = tempw;

num2 = xlsread('logitresults.xlsx');

params = [num2(:,2); 1];
plength = length(params);
xvars = [logitterm netweeksout netweeksout_sqr nqsubscribers week_ind(:,2:56) year_ind(:,2:10) ones(length(theta),1) theta];


ms_pred = zeros(numobs,1);
errors = logmsdiff-xvars*params;
group = 1*lowbudget+2*medbudget+3*highbudget;

gross_ne = zeros(numobs,1);
ms_ne = zeros(numobs,1);
ticketprice_m = zeros(numm,1);
population_m = zeros(numm,1);
for m=1:numm
   m1 = market_delim(m,1);
   m2 = market_delim(m,2);
   ms_pred(m1:m2) = findms_nest(params(2:plength),params(1),xvars(m1:m2,2:plength),[errors(m1:m2) zeros(m2-m1+1,2)]);
   ms_ne(m1:m2) = findms_nest(params(2:plength),params(1),xvars(m1:m2,2:plength),zeros(m2-m1+1,3));
   gross_ne(m1:m2) = ms_ne(m1:m2)*population(m1)*ticketprice(m1);
   ticketprice_m(m) = ticketprice(m1);
   population_m(m) = population(m1);
end

num3 = xlsread('distribution.xlsx');

budget_mean = num3(:,2);
budget_sd = num3(:,4);
budget_skew = num3(:,6);
budget_kurt = num3(:,7);
theta_mean = num3(:,3);
theta_sd = num3(:,5);
theta_skew = num3(:,8);
theta_kurt = num3(:,9);

minb_all = [1000000;21000000;101000000];
maxb_all = [20000000;100000000;300000000];


% num5 = xlsread('thetadist_bybudget.xlsx'); 
% thetadistparams_l = num5(:,1);
% thetadistparams_m = num5(:,2);
% thetadistparams_h = num5(:,3);


posweeks = zeros(10,53);
for y=1:10
    tempi = 0;
    for k=1:56
        tempy = y+2008;
        r = find(marketid(:,1)==tempy & marketid(:,2)==k);
        if(~isempty(r))
           tempi=tempi+1;
           posweeks(y,tempi) = k;      
        end
    end
    
end

num4 = xlsread('thetaregs.xlsx');
budgetcoef = num4(1,:)';

thetacoef_l = num4(:,1);
thetacoef_m = num4(:,2);
thetacoef_h = num4(:,3);
theta_raw = theta;
theta(logical(lowbudget)) = [log(budget(logical(lowbudget))) dist_ind(logical(lowbudget),2:7) zeros(sum(lowbudget),2) ones(sum(lowbudget),1) year_ind(logical(lowbudget),2:10)]*thetacoef_l;
theta(logical(medbudget)) = [log(budget(logical(medbudget))) dist_ind(logical(medbudget),2:7) zeros(sum(medbudget),1) ones(sum(medbudget),1) ones(sum(medbudget),1) year_ind(logical(medbudget),2:10)]*thetacoef_m;
theta(logical(highbudget)) = [log(budget(logical(highbudget))) dist_ind(logical(highbudget),2:7) ones(sum(highbudget),1) zeros(sum(highbudget),1) ones(sum(highbudget),1) year_ind(logical(highbudget),2:10)]*thetacoef_h;

maxnumweeks = 6;

data = [year week titlecode distributorshort budgettype theta netweeksout budget gross_ne];

rnr = find(data(:,7)==1);
newreleases = data(rnr,:);
newreleases(1,:)=[];

tempdpre = data(1,:);

data_adj = zeros(3,9);
xvars_adj = zeros(3,size(xvars,2));
market_delim_adj = zeros(3,2);
tempc = 0;
for m=1:numm
   tempnew = find(newreleases(:,1)==marketid(m,1) & newreleases(:,2)==marketid(m,2));
   
   market_delim_adj(m,1) = tempc+1;
   
   tempdpre(:,1) = marketid(m,1);
   tempdpre(:,2) = marketid(m,2);
   
   tempd = [newreleases(tempnew,:); tempdpre];
   tempn = size(tempd,1);
   tempc = tempc+tempn;
   
   market_delim_adj(m,2) = tempc;
   m1 = market_delim_adj(m,1);
   m2 = tempc;
   
   data_adj(m1:m2,:)=tempd;
   
   tempnqsubs = mnqsubscribers(m)*ones(tempn,1);
   tempyind = zeros(tempn,10);
   tempyind(:,marketid(m,1)-2008)=1;
   tempwind = zeros(tempn,56);
   tempwind(:,marketid(m,2))=1;
   xvars_adj(m1:m2,:) = [zeros(tempn,1) tempd(:,7) tempd(:,7).^2 tempnqsubs tempwind(:,2:56) tempyind(:,2:10) ones(tempn,1) tempd(:,6)];
   
   tempms = findms_nest(params(2:plength),params(1),xvars_adj(m1:m2,2:plength),zeros(tempn,3));
   data_adj(m1:m2,9) = tempms*population_m(m)*ticketprice_m(m);
   
   tempdpre = data_adj(m1:m2,:);
   tempdpre(:,7) = tempdpre(:,7)+1;
   tempdpre(tempdpre(:,7)>maxnumweeks,:)=[];

end

for m=numm+1:numm+6
    tempnew = [];
    
    market_delim_adj(m,1) = tempc+1;
    
    tempdpre(:,1) = 2019;
    tempdpre(:,2) = m-numm;
    
    tempd = [2019 m-numm max(data_adj(:,3))+1 1 2 -3.5 1 50000000 0; tempdpre];
    tempn = size(tempd,1);
    tempc = tempc+tempn;
    
    market_delim_adj(m,2) = tempc;
    m1 = market_delim_adj(m,1);
    m2 = tempc;
    
    data_adj(m1:m2,:)=tempd;
    
    tempnqsubs = 148.86*ones(tempn,1); %2019 Q1 Subscribers
    tempyind = zeros(tempn,10);
    tempyind(:,2018-2008)=1;
    tempwind = zeros(tempn,56);
    tempwind(:,m-numm)=1;
    xvars_adj(m1:m2,:) = [zeros(tempn,1) tempd(:,7) tempd(:,7).^2 tempnqsubs tempwind(:,2:56) tempyind(:,2:10) ones(tempn,1) tempd(:,6)];
    
    tempms = findms_nest(params(2:plength),params(1),xvars_adj(m1:m2,2:plength),zeros(tempn,3));
    data_adj(m1:m2,9) = tempms*population_m(numm)*ticketprice_m(numm);
    
    tempdpre = data_adj(m1:m2,:);
    tempdpre(:,7) = tempdpre(:,7)+1;
    %tempdpre(tempdpre(:,9)<mingross,:)=[];
    tempdpre(tempdpre(:,7)>maxnumweeks,:)=[];
    
    marketid(m,1) = 2019;
    marketid(m,2) = m-numm;
    marketid(m,3) = 1+((m-numm)>4);
    mnqsubscribers(m) = 148.86;
    population_m(m) = population_m(numm);
    ticketprice_m(m) = ticketprice_m(numm);
end

year_delim_adj = zeros(11,2);
for y=1:10
   year_delim_adj(y,1)=market_delim_adj(year_delim2(y,1),1);
   year_delim_adj(y,2)=market_delim_adj(year_delim2(y,2),2);
end
year_delim_adj(11,1)=market_delim_adj(numm+1,1);
year_delim_adj(11,2)=market_delim_adj(numm+6,2);

weeksinyear = zeros(10,1);
for y=1:10
    t = find(posweeks(y,:)==0,1,'first');
    if(~isempty(t))
        weeksinyear(y) = t-1;
    else
        weeksinyear(y) = size(posweeks,2);
    end
end

%Give zero shocks to arrange release dates initially
xshocks = zeros(length(xvars_adj),3);
dshocks = zeros(1,max(data_adj(:,3)),max(weeksinyear)+5);
qshocks = zeros(1,max(data_adj(:,3)));
wmshocks = zeros(1,max(data_adj(:,3)),max(weeksinyear));
    
for y=1:10
    y
    tempy = y+2008;
    
    [data_adj xvars_adj xshocks market_delim_adj] = weekadjust(data_adj,xvars_adj,market_delim_adj,params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,[population_m ticketprice_m],mnqsubscribers,xshocks,dshocks,qshocks,wmshocks,[1;1;1]);

end

%Adjust year_delim
for y=1:10
   r = find(data_adj(:,1)==y+2008); 
   year_delim_adj(y,2)=max(r);
   year_delim_adj(y+1,1)=max(r)+1;
end
r = find(data_adj(:,1)==11+2008);
year_delim_adj(11,2)=max(r);


%Draw shocks
tweeks = max(weeksinyear);
allmovies = unique(data_adj(:,3));
tmovies = length(allmovies);

%Movie-Week Demand Shocks
nshocks1 = 30;
dshocksd = 0.001;
dshocks = normrnd(0,dshocksd,[nshocks1,tmovies,tweeks+5]);

%Movie-Quality Shocks
nshocks2 = 30;
qshocksd = 0.001;
qshocks = normrnd(0,qshocksd,[nshocks2,tmovies]);

%Movie-ReleaseDate Shocks
nshocks3 = 1; %Change the number of movie release date shocks to one to keep the computation time manageable %OUR CHANGE
wmshocksd = 0.001;
wmshocks = normrnd(0,wmshocksd,[nshocks3,tmovies,tweeks]);

data = [year week titlecode distributorshort budgettype theta netweeksout budget gross_ne];