%clear
%load('fixedcostestimation_sim.mat')

%Some of upper bounds are unbounded so need to set the bound
%Set to mean distance between lower and upper bound across the years
for s=2:7
    meandiff_l = mean(fc_lb_ub(fc_lb_ub(:,s)~=0,s)-fc_lb_lb(fc_lb_ub(:,s)~=0,s));
    meandiff_m = mean(fc_mb_ub(fc_mb_ub(:,s)~=0,s)-fc_mb_lb(fc_mb_ub(:,s)~=0,s));
    meandiff_h = mean(fc_hb_ub(fc_hb_ub(:,s)~=0,s)-fc_hb_lb(fc_hb_ub(:,s)~=0,s));
    
    fc_lb_ub(fc_lb_ub(:,s)==0,s)=fc_lb_lb(fc_lb_ub(:,s)==0,s)+meandiff_l;
    fc_mb_ub(fc_mb_ub(:,s)==0,s)=fc_mb_lb(fc_mb_ub(:,s)==0,s)+meandiff_m;
    fc_hb_ub(fc_hb_ub(:,s)==0,s)=fc_hb_lb(fc_hb_ub(:,s)==0,s)+meandiff_h;
end



%Set fixed costs at the midpoint between the bounds
fc_lb = (fc_lb_lb+fc_lb_ub)/2;
fc_mb = (fc_mb_lb+fc_mb_ub)/2;
fc_hb = (fc_hb_lb+fc_hb_ub)/2;

data_cf = repmat({data},nshocks3,1);
xvars_cf = repmat({xvars},nshocks3,1);
xshocks_cf = repmat({xshocks},nshocks3,1);
market_delim_cf = repmat({market_delim},nshocks3,1);
year_delim_cf = repmat({year_delim},nshocks3,1);

dshocks_cf = repmat({dshocks},nshocks3,1);
qshocks_cf = repmat({qshocks},nshocks3,1);
wmshocks_cf = repmat({wmshocks},nshocks3,1);

%Use to compare to observed (before adjust future years)
gross_compare_cf = repmat({zeros(5,5)},nshocks3,1);
gclimit=ones(nshocks3,1);

marketchars = [population_m ticketprice_m];

nmovies_lb_cf = repmat({nmovies_lb},nshocks3,1);
nmovies_mb_cf = repmat({nmovies_mb},nshocks3,1);
nmovies_hb_cf = repmat({nmovies_hb},nshocks3,1);
nmovies_all_cf = repmat({nmovies_all},nshocks3,1);

mintheta_lb_cf = mintheta_lb;
mintheta_mb_cf = mintheta_mb;
mintheta_hb_cf = mintheta_hb;

minbudget_lb_cf = minbudget_lb;
minbudget_mb_cf = minbudget_mb;
minbudget_hb_cf = minbudget_hb;

%Create potential movies to add for each studio
maxnumadds = 10; %Set to max number of ideas each year

%Hold ideas in (Y*S x 3) matrix that for each year-studio contains the 

movieideas_l = repmat({zeros(60,maxnumadds,3)},nshocks3,1);
movieideas_m = repmat({zeros(60,maxnumadds,3)},nshocks3,1);
movieideas_h = repmat({zeros(60,maxnumadds,3)},nshocks3,1);

for n=1:nshocks3
   dshocks_cf{n} = [dshocks_cf{n} zeros(nshocks1,10*6*3*maxnumadds,tweeks+5)];
   qshocks_cf{n} = [qshocks_cf{n} zeros(nshocks2,10*6*3*maxnumadds)];
   wmshocks_cf{n} = [wmshocks_cf{n} zeros(nshocks3,10*6*3*maxnumadds,tweeks)];
   
   wmshocks_cf{n} = squeeze(wmshocks_cf{n}(n,:,:));
end

twmshocks_cf = [wmshocks zeros(nshocks3,10*6*3*maxnumadds,tweeks)];

titlecodestart=max(data(:,3));
for y=1:10
    tempy = zeros(1,10);
    tempy(1,y)=1;
    for s=2:7
        tempd = zeros(1,6);
        tempd(1,s-1)=1;
        
        %Same demand and quality shocks for each release date shock
        %(same as FC estimation)
        
        tdsl = normrnd(0,dshocksd,[nshocks1,maxnumadds,tweeks+5]);
        tdsm = normrnd(0,dshocksd,[nshocks1,maxnumadds,tweeks+5]);
        tdsh = normrnd(0,dshocksd,[nshocks1,maxnumadds,tweeks+5]);
        
        tqsl = normrnd(0,qshocksd,[nshocks2,maxnumadds]);
        tqsm = normrnd(0,qshocksd,[nshocks2,maxnumadds]);
        tqsh = normrnd(0,qshocksd,[nshocks2,maxnumadds]);
        
        for n=1:nshocks3
                      
            twmsl = normrnd(0,wmshocksd,[maxnumadds,tweeks]);
            twmsm = normrnd(0,wmshocksd,[maxnumadds,tweeks]);
            twmsh = normrnd(0,wmshocksd,[maxnumadds,tweeks]);
            
            for i=1:maxnumadds
                %Assume different movie budget draws for different release
                %date shocks (same as FC estimation)
                movieideas_l{n}((y-1)*6+(s-1),i,2) = budget_mean(1)+budget_sd(1)*trandn((0-budget_mean(1))/budget_sd(1),(minbudget_lb_cf{n}(y,s)-budget_mean(1))/budget_sd(1));
                minbudget_lb_cf{n}(y,s) = movieideas_l{n}((y-1)*6+(s-1),i,2);
                movieideas_m{n}((y-1)*6+(s-1),i,2) = budget_mean(2)+budget_sd(2)*trandn((maxb_all(1)-budget_mean(2))/budget_sd(2),(minbudget_mb_cf{n}(y,s)-budget_mean(2))/budget_sd(2));
                minbudget_mb_cf{n}(y,s) = movieideas_m{n}((y-1)*6+(s-1),i,2);
                movieideas_h{n}((y-1)*6+(s-1),i,2) = budget_mean(3)+budget_sd(3)*trandn((maxb_all(2)-budget_mean(3))/budget_sd(3),(minbudget_hb_cf{n}(y,s)-budget_mean(3))/budget_sd(3));
                minbudget_hb_cf{n}(y,s) = movieideas_h{n}((y-1)*6+(s-1),i,2);
                
                movieideas_l{n}((y-1)*6+(s-1),i,1) = [log(movieideas_l{n}((y-1)*6+(s-1),i,2)) tempd 0 0 1 tempy(:,2:10)]*thetacoef_l;
                mintheta_lb_cf{n}(y,s) = movieideas_l{n}((y-1)*6+(s-1),i,1);
                movieideas_m{n}((y-1)*6+(s-1),i,1) = [log(movieideas_m{n}((y-1)*6+(s-1),i,2)) tempd 0 1 1 tempy(:,2:10)]*thetacoef_m;
                mintheta_mb_cf{n}(y,s) = movieideas_m{n}((y-1)*6+(s-1),i,1);
                movieideas_h{n}((y-1)*6+(s-1),i,1) = [log(movieideas_h{n}((y-1)*6+(s-1),i,2)) tempd 1 0 1 tempy(:,2:10)]*thetacoef_h;
                mintheta_hb_cf{n}(y,s) = movieideas_h{n}((y-1)*6+(s-1),i,1);
                
                movieideas_l{n}((y-1)*6+(s-1),i,3) = titlecodestart+(y-1)*6*maxnumadds*3+(s-2)*maxnumadds*3+(i-1)*3+1;
                movieideas_m{n}((y-1)*6+(s-1),i,3) = titlecodestart+(y-1)*6*maxnumadds*3+(s-2)*maxnumadds*3+(i-1)*3+2;
                movieideas_h{n}((y-1)*6+(s-1),i,3) = titlecodestart+(y-1)*6*maxnumadds*3+(s-2)*maxnumadds*3+(i-1)*3+3;
                
                dshocks_cf{n}(:,movieideas_l{n}((y-1)*6+(s-1),i,3),:) = tdsl(:,i,:);
                dshocks_cf{n}(:,movieideas_m{n}((y-1)*6+(s-1),i,3),:) = tdsm(:,i,:);
                dshocks_cf{n}(:,movieideas_h{n}((y-1)*6+(s-1),i,3),:) = tdsh(:,i,:);
                
                qshocks_cf{n}(:,movieideas_l{n}((y-1)*6+(s-1),i,3)) = tqsl(:,i);
                qshocks_cf{n}(:,movieideas_m{n}((y-1)*6+(s-1),i,3)) = tqsm(:,i);
                qshocks_cf{n}(:,movieideas_h{n}((y-1)*6+(s-1),i,3)) = tqsh(:,i);
                
                wmshocks_cf{n}(movieideas_l{n}((y-1)*6+(s-1),i,3),:) = twmsl(i,:);
                wmshocks_cf{n}(movieideas_m{n}((y-1)*6+(s-1),i,3),:) = twmsm(i,:);
                wmshocks_cf{n}(movieideas_h{n}((y-1)*6+(s-1),i,3),:) = twmsh(i,:);
                
            end
        end
        
    end  
end

for n=1:nshocks3
    twmshocks_cf(n,:,:) = wmshocks_cf{n};
end

tbudget_l = zeros(10,6);
tbudget_m = zeros(10,6);
tbudget_h = zeros(10,6);
for y=1:10
    for s=2:7
        r = find(data(:,1)==(y+2008) & data(:,5)==1 & data(:,7)==1 & data(:,4)==s);
        r2 = find(data(:,1)==(y+2008) & data(:,5)==2 & data(:,7)==1 & data(:,4)==s);
        r3 = find(data(:,1)==(y+2008) & data(:,5)==3 & data(:,7)==1 & data(:,4)==s);
        tbudget_l(y,s-1)=sum(data(r,8));
        tbudget_m(y,s-1)=sum(data(r2,8));
        tbudget_h(y,s-1)=sum(data(r3,8));
    end
end

tbudget = tbudget_l+tbudget_m+tbudget_h;

gross_comp_cf = cell(nshocks3,1);

for s3 = 1:nshocks3
%for s3 = 1:1
    s3
    
    txcol = nshocks1+nshocks2+s3;
    
    for m=1:length(market_delim_cf{s3})
        mstart = market_delim_cf{s3}(m,1);
        mend = market_delim_cf{s3}(m,2);
        temp = [mstart:mend];
        data_cf{s3}(temp,9) = expectedrevenue(xvars_cf{s3}(temp,2:plength),params,[marketchars(m,1); marketchars(m,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,txcol));
    end
    
    for y=1:10
        y
        tempy = y+2008;

        [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = weekadjust(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,xshocks_cf{s3},dshocks_cf{s3},qshocks_cf{s3},twmshocks_cf,[nshocks1;nshocks2;s3]);
        
        eq = 1;
        
        while(eq)
            
            nlb_old = nmovies_lb_cf{s3}(y,:);
            nmb_old = nmovies_mb_cf{s3}(y,:);
            nhb_old = nmovies_hb_cf{s3}(y,:);
            
            dflag = 1;
            while(dflag)
                %Allow each studio to drop unprofitable movies
                tempdiff = zeros(6,3);
                tempdrop_all = zeros(6,3);
                for s=2:7
                    %Find all the movies made by that studio and drop the ones that have profit less than the fixed cost
                    rall = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    tempsmovies = data_cf{s3}(rall,3);
                    
                    maxbudget = nmovies_lb_cf{s3}(y,s)*maxb_all(1)+nmovies_mb_cf{s3}(y,s)*maxb_all(2)+nmovies_hb_cf{s3}(y,s)*maxb_all(3);
                    
                    ydec = zeros(3,1);
                    if(nmovies_lb_cf{s3}(y,s)>0 && tbudget(y,s-1)<(maxbudget-maxb_all(1)))
                        ydec(1)=1;
                    end
                    if(nmovies_mb_cf{s3}(y,s)>0 && tbudget(y,s-1)<(maxbudget-maxb_all(2)))
                        ydec(2)=1;
                    end
                    if(nmovies_hb_cf{s3}(y,s)>0 && tbudget(y,s-1)<(maxbudget-maxb_all(3)))
                        ydec(3)=1;
                    end
                    
                    rl = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==1 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rm = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==2 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rh = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==3 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    
                    %Low Budget
                    if(ydec(1))
                        r = rl;
                        templmovies = data_cf{s3}(r,3);
                        temptheta = data_cf{s3}(r,6);
                        tempchange_all = zeros(nmovies_lb_cf{s3}(y,s),2);
                        for j=1:nmovies_lb_cf{s3}(y,s)
                            tempdrop = templmovies(j);
                            tempchange_all(j,2)=tempdrop;
                            
                            if(nmovies_all_cf{s3}(y,s)>1)
                                [data_temp xvars_temp xshocks_temp market_delim_temp] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,s,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                
                                tempchange_all(j,1) = sum(data_temp(data_temp(:,4)==s,9))-sum(data_cf{s3}(data_cf{s3}(:,4)==s,9));
                                
                            else
                                r2 = find(data_cf{s3}(:,3)==tempdrop);
                                temprev = sum(data_cf{s3}(r2,9));
                                tempchange_all(j,1) = -temprev+data_cf{s3}(r(j),8);
                            end
                        end
                        
                        [minl minlow] = max(tempchange_all(:,1));
                        tempdiff(s-1,1) = minl+fc_lb(y,s);
                        tempdrop_all(s-1,1) = tempchange_all(minlow,2);
                        
                    else
                        tempdiff(s-1,1)=-1; %Not profitable to drop movie if no movies
                    end
                    
                    %Medium Budget
                    if(ydec(2))
                        r = rm;
                        tempmmovies = data_cf{s3}(r,3);
                        temptheta = data_cf{s3}(r,6);
                        tempchange_all = zeros(nmovies_mb_cf{s3}(y,s),2);
                        for j=1:nmovies_mb_cf{s3}(y,s)
                            tempdrop = tempmmovies(j);
                            tempchange_all(j,2)=tempdrop;
                            
                            if(nmovies_all_cf{s3}(y,s)>1)
                                [data_temp xvars_temp xshocks_temp market_delim_temp] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,s,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                
                                tempchange_all(j,1) = sum(data_temp(data_temp(:,4)==s,9))-sum(data_cf{s3}(data_cf{s3}(:,4)==s,9));
                                
                            else
                                r2 = find(data_cf{s3}(:,3)==tempdrop);
                                temprev = sum(data_cf{s3}(r2,9));
                                tempchange_all(j,1) = -temprev+data_cf{s3}(r(j),8);
                            end
                        end
                        
                        
                        [minl minlow] = max(tempchange_all(:,1));
                        tempdiff(s-1,2) = minl+fc_mb(y,s);
                        tempdrop_all(s-1,2) = tempchange_all(minlow,2);
                        
                    else
                        tempdiff(s-1,2)=-1; %Not profitable to drop movie if no movies
                    end
                    
                    %High Budget
                    if(ydec(3))
                        r = rh;
                        temphmovies = data_cf{s3}(r,3);
                        temptheta = data_cf{s3}(r,6);
                        tempchange_all = zeros(nmovies_hb_cf{s3}(y,s),2);
                        for j=1:nmovies_hb_cf{s3}(y,s)
                            tempdrop = temphmovies(j);
                            tempchange_all(j,2)=tempdrop;
                            
                            if(nmovies_all_cf{s3}(y,s)>1)
                                [data_temp xvars_temp xshocks_temp market_delim_temp] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,s,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                
                                tempchange_all(j,1) = sum(data_temp(data_temp(:,4)==s,9))-sum(data_cf{s3}(data_cf{s3}(:,4)==s,9));
                                
                            else
                                r2 = find(data_cf{s3}(:,3)==tempdrop);
                                temprev = sum(data_cf{s3}(r2,9));
                                tempchange_all(j,1) = -temprev+data_cf{s3}(r(j),8);
                            end
                            
                        end
                        
                        [minl minlow] = max(tempchange_all(:,1));
                        tempdiff(s-1,3) = minl+fc_hb(y,s);
                        tempdrop_all(s-1,3) = tempchange_all(minlow,2);
                        
                    else
                        tempdiff(s-1,3)=-1; %Not profitable to drop movie if no movies
                    end
                    
                end
                
                [maxvf maxr] = max(tempdiff);
                [maxv maxb] = max(maxvf);
                maxs = maxr(maxb);
                
                %maxs is studio with max value
                %maxb is budget type with max value
                %maxv is max value
                
                if(maxv>0) %If dropping any movie increases profit
                    temps = maxs+1;
                    tempn = nmovies_all_cf{s3}(y,temps);
                    tempdrop = tempdrop_all(maxs,maxb);
                    r3 = find(data_cf{s3}(:,3)==tempdrop);
                    tempb = data_cf{s3}(r3(1),8);
                    tempt = data_cf{s3}(r3(1),6);
                    tempc = data_cf{s3}(r3(1),3);
                    
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,temps,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                    
                    %Add dropped movie to list of ideas
                    %Change number of movies of each type
                    if(maxb==1)
                        nmovies_lb_cf{s3}(y,temps)=nmovies_lb_cf{s3}(y,temps)-1;
                        movieideas_l{s3}((y-1)*6+(temps-1),2:end+1,:)=squeeze(movieideas_l{s3}((y-1)*6+(temps-1),:,:));
                        movieideas_l{s3}((y-1)*6+(temps-1),1,:)=[tempt tempb tempc];
                    elseif(maxb==2)
                        nmovies_mb_cf{s3}(y,temps)=nmovies_mb_cf{s3}(y,temps)-1;
                        movieideas_m{s3}((y-1)*6+(temps-1),2:end+1,:)=squeeze(movieideas_m{s3}((y-1)*6+(temps-1),:,:));
                        movieideas_m{s3}((y-1)*6+(temps-1),1,:)=[tempt tempb tempc];
                    else
                        nmovies_hb_cf{s3}(y,temps)=nmovies_hb_cf{s3}(y,temps)-1;
                        movieideas_h{s3}((y-1)*6+(temps-1),2:end+1,:)=squeeze(movieideas_h{s3}((y-1)*6+(temps-1),:,:));
                        movieideas_h{s3}((y-1)*6+(temps-1),1,:)=[tempt tempb tempc];
                    end
                    nmovies_all_cf{s3}(y,temps) = nmovies_all_cf{s3}(y,temps)-1;
                    
                    %Now give other films a chance to move around
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = weekadjust(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,xshocks_cf{s3},dshocks_cf{s3},qshocks_cf{s3},twmshocks_cf,[nshocks1;nshocks2;s3]);
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    
                else
                    dflag=0;
                    
                end
                
            end
            
            aflag = 1;
            while(aflag)
                %Allow studios to add profitable movies
                tempdiff = zeros(6,3); %Holds change in profit for adding move
                tempaddweek = zeros(6,3); %Holds best week to release movie
                %temptotweeks = zeros(6,3); %Holds how long movie is held in theaters
                for s=2:7
                    %Create CF movie for studio and add like in fixedcostestimation
                    %If profit is above fixed cost than add movie
                    
                    minb = nmovies_lb_cf{s3}(y,s)*minb_all(1)+nmovies_mb_cf{s3}(y,s)*minb_all(2)+nmovies_hb_cf{s3}(y,s)*minb_all(3);
                    
                    %                 yadd = [(~isempty(movieideas_l{y,s-1}))*(tbudget(y,s-1)>=(minb+minb_all(1)));...
                    %                     (~isempty(movieideas_m{y,s-1}))*(tbudget(y,s-1)>=(minb+minb_all(2)));...
                    %                     (~isempty(movieideas_h{y,s-1}))*(tbudget(y,s-1)>=(minb+minb_all(3)))];
                    
                    yadd = [(movieideas_l{s3}((y-1)*6+(s-1),1,3)~=0); (movieideas_m{s3}((y-1)*6+(s-1),1,3)~=0); (movieideas_h{s3}((y-1)*6+(s-1),1,3)~=0)];
                    if(yadd(1))
                        if((tbudget(y,s-1)<(minb+movieideas_l{s3}((y-1)*6+(s-1),1,2))))
                            yadd(1)=0;
                        end
                    end
                    if(yadd(2))
                        if((tbudget(y,s-1)<(minb+movieideas_m{s3}((y-1)*6+(s-1),1,2))))
                            yadd(2)=0;
                        end
                    end
                    if(yadd(3))
                        if((tbudget(y,s-1)<(minb+movieideas_h{s3}((y-1)*6+(s-1),1,2))))
                            yadd(3)=0;
                        end
                    end
                    
                    rall = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    ball = sum(data_cf{s3}(rall,8));
                    rlow = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==1 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rmed = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==2 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rhigh = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==3 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    
                    samprevenues_byrweek_l = zeros(weeksinyear(y),1);
                    %Low Budget
                    if(yadd(1))
                        tempb_l = movieideas_l{s3}((y-1)*6+(s-1),1,2);
                        tempt_l = movieideas_l{s3}((y-1)*6+(s-1),1,1);
                        tempxvars_l = xvars_cf{s3}(:,2:plength);
                        tempde_l = dshocks_cf{s3}(:,movieideas_l{s3}((y-1)*6+(s-1),1,3),:);
                        tempqe_l = qshocks_cf{s3}(:,movieideas_l{s3}((y-1)*6+(s-1),1,3));
                        tempwme_l = twmshocks_cf(:,movieideas_l{s3}((y-1)*6+(s-1),1,3),:);
                        
                        blow_temp = data_cf{s3}(rall,8)-(data_cf{s3}(rall,8)/ball)*tempb_l;
                        adjustf = 1;
                        while(adjustf==1)
                            adjustf=0;
                            ti = find(ismember(rall,rlow));
                            if(sum(blow_temp(ti)<0)~=0)
                                rt = find(blow_temp(ti)<0);
                                addback = min(data_cf{s3}(rall(ti(rt)),8),1000000)-blow_temp(ti(rt));
                                blow_temp(ti(rt)) = blow_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                blow_temp(rtno)=blow_temp(rtno)-(blow_temp(rtno)/sum(blow_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rmed));
                            if(sum(blow_temp(ti)<maxb_all(1))~=0)
                                rt = find(blow_temp(ti)<maxb_all(1));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(2))-blow_temp(ti(rt));
                                blow_temp(ti(rt)) = blow_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                blow_temp(rtno)=blow_temp(rtno)-(blow_temp(rtno)/sum(blow_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(blow_temp(ti)<maxb_all(2))~=0)
                                rt = find(blow_temp(ti)<maxb_all(2));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(3))-blow_temp(ti(rt));
                                blow_temp(ti(rt)) = blow_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                blow_temp(rtno)=blow_temp(rtno)-(blow_temp(rtno)/sum(blow_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                        end
                        
                        for k=1:length(rall)
                            tempxvars_l(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)=tempxvars_l(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)+budgetcoef(4-data_cf{s3}(rall(k),5))*(log(blow_temp(k))-log(data_cf{s3}(rall(k),8)));
                        end
                        
                        rall2 = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,4)==s);
                        r2f = find(ismember(data_cf{s3}(:,3),data_cf{s3}(rall2,3)));
                        [t ti] = unique((data_cf{s3}(r2f,1)-2000)*60+data_cf{s3}(r2f,2));
                        r2 = r2f(ti);
                        tempchange_l = zeros(length(r2),3);
                        for l=1:length(r2)
                            r = find(marketid(:,1)==data_cf{s3}(r2(l),1) & marketid(:,2)==data_cf{s3}(r2(l),2));
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            %tempms = findms_nest(params(2:plength),params(1),tempxvars_l(temp,:),zeros(tempn,1));
                            %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                            temprev = expectedrevenue(tempxvars_l(temp,:),params,[marketchars(r,1); marketchars(r,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,nshocks1+nshocks2+s3));
                            tempgross = data_cf{s3}(temp,9);
                            tempdist = (data_cf{s3}(temp,4)==s);
                            tempchange_l(l,1) = sum(temprev(tempdist)-tempgross(tempdist));
                            tempchange_l(l,2) = data_cf{s3}(r2(l),1);
                            tempchange_l(l,3) = data_cf{s3}(r2(l),2);
                        end
                        
                    else
                        tempchange_l = zeros(1,3);
                    end
                    
                    samprevenues_byrweek_m = zeros(weeksinyear(y),1);
                    %Medium Budget
                    if(yadd(2))
                        tempb_m = movieideas_m{s3}((y-1)*6+(s-1),1,2);
                        tempt_m = movieideas_m{s3}((y-1)*6+(s-1),1,1);
                        tempxvars_m = xvars_cf{s3}(:,2:plength);
                        tempde_m = dshocks_cf{s3}(:,movieideas_m{s3}((y-1)*6+(s-1),1,3),:);
                        tempqe_m = qshocks_cf{s3}(:,movieideas_m{s3}((y-1)*6+(s-1),1,3));
                        tempwme_m = wmshocks_cf{s3}(movieideas_m{s3}((y-1)*6+(s-1),1,3),:);
                        
                        bmed_temp = data_cf{s3}(rall,8)-(data_cf{s3}(rall,8)/ball)*tempb_m;
                        adjustf = 1;
                        while(adjustf==1)
                            adjustf=0;
                            ti = find(ismember(rall,rlow));
                            if(sum(bmed_temp(ti)<0)~=0)
                                rt = find(bmed_temp(ti)<0);
                                addback = min(data_cf{s3}(rall(ti(rt)),8),1000000)-bmed_temp(ti(rt));
                                bmed_temp(ti(rt)) = bmed_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bmed_temp(rtno)=bmed_temp(rtno)-(bmed_temp(rtno)/sum(bmed_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rmed));
                            if(sum(bmed_temp(ti)<maxb_all(1))~=0)
                                rt = find(bmed_temp(ti)<maxb_all(1));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(2))-bmed_temp(ti(rt));
                                bmed_temp(ti(rt)) = bmed_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bmed_temp(rtno)=bmed_temp(rtno)-(bmed_temp(rtno)/sum(bmed_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(bmed_temp(ti)<maxb_all(2))~=0)
                                rt = find(bmed_temp(ti)<maxb_all(2));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(3))-bmed_temp(ti(rt));
                                bmed_temp(ti(rt)) = bmed_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bmed_temp(rtno)=bmed_temp(rtno)-(bmed_temp(rtno)/sum(bmed_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                        end
                        
                        for k=1:length(rall)
                            tempxvars_m(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)=tempxvars_m(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)+budgetcoef(4-data_cf{s3}(rall(k),5))*(log(bmed_temp(k))-log(data_cf{s3}(rall(k),8)));
                        end
                        
                        rall2 = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,4)==s);
                        r2f = find(ismember(data_cf{s3}(:,3),data_cf{s3}(rall2,3)));
                        [t ti] = unique((data_cf{s3}(r2f,1)-2000)*60+data_cf{s3}(r2f,2));
                        r2 = r2f(ti);
                        tempchange_m = zeros(length(r2),3);
                        for l=1:length(r2)
                            r = find(marketid(:,1)==data_cf{s3}(r2(l),1) & marketid(:,2)==data_cf{s3}(r2(l),2));
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            %tempms = findms_nest(params(2:plength),params(1),tempxvars_m(temp,:),zeros(tempn,1));
                            %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                            temprev = expectedrevenue(tempxvars_m(temp,:),params,[marketchars(r,1); marketchars(r,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,nshocks1+nshocks2+s3));
                            tempgross = data_cf{s3}(temp,9);
                            tempdist = (data_cf{s3}(temp,4)==s);
                            tempchange_m(l,1) = sum(temprev(tempdist)-tempgross(tempdist));
                            tempchange_m(l,2) = data_cf{s3}(r2(l),1);
                            tempchange_m(l,3) = data_cf{s3}(r2(l),2);
                        end
                        
                    else
                        tempchange_m = zeros(1,3);
                    end
                    
                    samprevenues_byrweek_h = zeros(weeksinyear(y),1);
                    %High Budget
                    if(yadd(3)) 
                        tempb_h = movieideas_h{s3}((y-1)*6+(s-1),1,2);
                        tempt_h = movieideas_h{s3}((y-1)*6+(s-1),1,1);
                        tempxvars_h = xvars_cf{s3}(:,2:plength);
                        tempde_h = dshocks_cf{s3}(:,movieideas_h{s3}((y-1)*6+(s-1),1,3),:);
                        tempqe_h = qshocks_cf{s3}(:,movieideas_h{s3}((y-1)*6+(s-1),1,3));
                        tempwme_h = wmshocks_cf{s3}(movieideas_h{s3}((y-1)*6+(s-1),1,3),:);
                        
                        bhigh_temp = data_cf{s3}(rall,8)-(data_cf{s3}(rall,8)/ball)*tempb_h;
                        adjustf = 1;
                        while(adjustf==1)
                            adjustf=0;
                            ti = find(ismember(rall,rlow));
                            if(sum(bhigh_temp(ti)<0)~=0)
                                rt = find(bhigh_temp(ti)<0);
                                addback = min(data_cf{s3}(rall(ti(rt)),8),1000000)-bhigh_temp(ti(rt));
                                bhigh_temp(ti(rt)) = bhigh_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bhigh_temp(rtno)=bhigh_temp(rtno)-(bhigh_temp(rtno)/sum(bhigh_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(bhigh_temp(ti)<maxb_all(1))~=0)
                                rt = find(bhigh_temp(ti)<maxb_all(1));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(2))-bhigh_temp(ti(rt));
                                bhigh_temp(ti(rt)) = bhigh_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bhigh_temp(rtno)=bhigh_temp(rtno)-(bhigh_temp(rtno)/sum(bhigh_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(bhigh_temp(ti)<maxb_all(2))~=0)
                                rt = find(bhigh_temp(ti)<maxb_all(2));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(3))-bhigh_temp(ti(rt));
                                bhigh_temp(ti(rt)) = bhigh_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bhigh_temp(rtno)=bhigh_temp(rtno)-(bhigh_temp(rtno)/sum(bhigh_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                        end
                        
                        for k=1:length(rall)
                            tempxvars_h(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)=tempxvars_h(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)+budgetcoef(4-data_cf{s3}(rall(k),5))*(log(bhigh_temp(k))-log(data_cf{s3}(rall(k),8)));
                        end
                        
                        rall2 = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,4)==s);
                        r2f = find(ismember(data_cf{s3}(:,3),data_cf{s3}(rall2,3)));
                        [t ti] = unique((data_cf{s3}(r2f,1)-2000)*60+data_cf{s3}(r2f,2));
                        r2 = r2f(ti);
                        tempchange_h = zeros(length(r2),3);
                        for l=1:length(r2)
                            r = find(marketid(:,1)==data_cf{s3}(r2(l),1) & marketid(:,2)==data_cf{s3}(r2(l),2));
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            %tempms = findms_nest(params(2:plength),params(1),tempxvars_h(temp,:),zeros(tempn,1));
                            %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                            temprev = expectedrevenue(tempxvars_h(temp,:),params,[marketchars(r,1); marketchars(r,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,nshocks1+nshocks2+s3));
                            tempgross = data_cf{s3}(temp,9);
                            tempdist = (data_cf{s3}(temp,4)==s);
                            tempchange_h(l,1) = sum(temprev(tempdist)-tempgross(tempdist));
                            tempchange_h(l,2) = data_cf{s3}(r2(l),1);
                            tempchange_h(l,3) = data_cf{s3}(r2(l),2);
                        end
                        
                    else
                        tempchange_h = zeros(1,3);
                    end
                    
                    %totweeks = zeros(weeksinyear(y),3); %Holds the total weeks that the 3 movies stays released
                    
                    for w=1:weeksinyear(y)
                        tempw = posweeks(y,w);
                        temprevw = zeros(maxnumweeks,3); %Holds the weekly revene for each week the 3 movies play
                        tempweeks = zeros(maxnumweeks,3); %Holds the index of the week for each week the 3 movies play
                        %stillin = ones(3,1); %Equal to 1 if the movie is still playing
                        for k=1:maxnumweeks
                            if(w+k-1<weeksinyear(y)+1)
                                r = find(marketid(:,1)==tempy & marketid(:,2)==posweeks(y,w+k-1));
                                tempw=(tempy-2000)*60+posweeks(y,w+k-1);
                            elseif(tempy<2018)
                                r = find(marketid(:,1)==(tempy+1) & marketid(:,2)==posweeks(y+1,w+k-1-weeksinyear(y)));
                                tempw=(tempy+1-2000)*60+posweeks(y+1,w+k-1-weeksinyear(y));
                            else
                                r = find(marketid(:,1)==2019 & marketid(:,2)==(w+k-1-weeksinyear(y)));
                                tempw=(2019-2000)*60+(w+k-1-weeksinyear(y));
                            end
                            
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            rd = find(data_cf{s3}(temp,4)==s);
                            
                            tempmqs = mnqsubscribers(r);
                            tempweek = zeros(1,56);
                            tempweek(1,marketid(r,2))=1;
                            tempyear = zeros(1,10);
                            tempyear(1,marketid(r,1)-2008)=1;
                            
                            tempgroup = data_cf{s3}(temp,5);
                            
                            if(yadd(1))
                                tempweeks(k,1)=tempw;
                                
                                tempxvars_new = [k k^2 tempmqs tempweek(:,2:56) tempyear(:,2:10) 1 tempt_l];
                                tempxvars = [tempxvars_l(temp,:); tempxvars_new];
                                temperrors = [xshocks_cf{s3}(temp,:); squeeze(tempde_l(:,1,w+k-1))' tempqe_l' tempwme_l(:,w)'];
                                
                                %tempms = findms_nest(params(2:plength),params(1),tempxvars,temperrors);
                                %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                                temprev = expectedrevenue(tempxvars,params,[population_m(r); ticketprice_m(r)],temperrors(:,1:nshocks1),temperrors(:,nshocks1+1:nshocks1+nshocks2),temperrors(:,txcol));
                                temprevw(k,1) = temprev(tempn+1)-(sum(data_cf{s3}(mstart+rd-1,9))-sum(temprev(rd)));
                                %if(temprev(tempn+1)<mingross)
                                %    stillin(1)=0;
                                %    totweeks(w,1)= k;
                                %end
                            else
                                temprevw(k,1)=0;
                            end
                            
                            if(yadd(2))
                                tempweeks(k,2)=tempw;
                                
                                tempxvars_new = [k k^2 tempmqs tempweek(:,2:56) tempyear(:,2:10) 1 tempt_m];
                                tempxvars = [tempxvars_m(temp,:); tempxvars_new];
                                temperrors = [xshocks_cf{s3}(temp,:); squeeze(tempde_m(:,1,w+k-1))' tempqe_m' tempwme_l(:,w)'];
                                
                                %tempms = findms_nest(params(2:plength),params(1),tempxvars,temperrors);
                                %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                                temprev = expectedrevenue(tempxvars,params,[population_m(r); ticketprice_m(r)],temperrors(:,1:nshocks1),temperrors(:,nshocks1+1:nshocks1+nshocks2),temperrors(:,txcol));
                                temprevw(k,2) = temprev(tempn+1)-(sum(data_cf{s3}(mstart+rd-1,9))-sum(temprev(rd)));
                                %if(temprev(tempn+1)<mingross)
                                %    stillin(2)=0;
                                %    totweeks(w,2)= k;
                                %end
                            else
                                temprevw(k,2)=0;
                            end
                            
                            if(yadd(3))
                                tempweeks(k,3)=tempw;
                                
                                tempxvars_new = [k k^2 tempmqs tempweek(:,2:56) tempyear(:,2:10) 1 tempt_h];
                                tempxvars = [tempxvars_h(temp,:); tempxvars_new];
                                temperrors = [xshocks_cf{s3}(temp,:); squeeze(tempde_h(:,1,w+k-1))' tempqe_h' tempwme_l(:,w)'];
                                
                                %tempms = findms_nest(params(2:plength),params(1),tempxvars,temperrors);
                                %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                                temprev = expectedrevenue(tempxvars,params,[population_m(r); ticketprice_m(r)],temperrors(:,1:nshocks1),temperrors(:,nshocks1+1:nshocks1+nshocks2),temperrors(:,txcol));
                                temprevw(k,3) = temprev(tempn+1)-(sum(data_cf{s3}(mstart+rd-1,9))-sum(temprev(rd)));
                                %if(temprev(tempn+1)<mingross)
                                %    stillin(3)=0;
                                %    totweeks(w,3)= k;
                                %end
                            else
                                temprevw(k,3)=0;
                            end
                            
                        end
                        
                        otherrevchange = zeros(3,1);
                        templ = (tempchange_l(:,2)-2000)*60+tempchange_l(:,3);
                        otherrevchange(1) = sum(tempchange_l(~ismember(templ,tempweeks(:,1))));
                        tempm = (tempchange_m(:,2)-2000)*60+tempchange_m(:,3);
                        otherrevchange(2) = sum(tempchange_m(~ismember(tempm,tempweeks(:,2))));
                        temph = (tempchange_h(:,2)-2000)*60+tempchange_h(:,3);
                        otherrevchange(3) = sum(tempchange_h(~ismember(temph,tempweeks(:,3))));
                        
                        samprevenues_byrweek_l(w) = sum(temprevw(:,1))+otherrevchange(1);
                        samprevenues_byrweek_m(w) = sum(temprevw(:,2))+otherrevchange(2);
                        samprevenues_byrweek_h(w) = sum(temprevw(:,3))+otherrevchange(3);
                        
                        %totweeks(w,logical(stillin))=10;
                        
                    end
                    
                    [rev_l tempaddweek(s-1,1)] = max(samprevenues_byrweek_l);
                    [rev_m tempaddweek(s-1,2)] = max(samprevenues_byrweek_m);
                    [rev_h tempaddweek(s-1,3)] = max(samprevenues_byrweek_h);
                    
                    tempdiff(s-1,1) = rev_l-fc_lb(y,s)*(yadd(1));
                    tempdiff(s-1,2) = rev_m-fc_mb(y,s)*(yadd(2));
                    tempdiff(s-1,3) = rev_h-fc_hb(y,s)*(yadd(3));
                    
                    %temptotweeks(s-1,1) = totweeks(tempaddweek(s-1,1),1);
                    %temptotweeks(s-1,2) = totweeks(tempaddweek(s-1,2),2);
                    %temptotweeks(s-1,3) = totweeks(tempaddweek(s-1,3),3);
                    
                end
                
                [maxvf maxr] = max(tempdiff);
                [maxv maxb] = max(maxvf);
                maxs = maxr(maxb);
                maxw = tempaddweek(maxs,maxb);
                %maxw2 = temptotweeks(maxs,maxb);
                
                %maxs is studio with max value
                %maxb is budget type with max value
                %maxv is max value
                %maxw is release week for film to be added
                %maxw2 is number of weeks to release movie
                
                if(maxv>0) %If adding any movie increases profit
                    temps = maxs+1;
                    
                    if(maxb==1)
                        tempb_add = movieideas_l{s3}((y-1)*6+(temps-1),1,2);
                        tempt_add = movieideas_l{s3}((y-1)*6+(temps-1),1,1);
                        tempc_add = movieideas_l{s3}((y-1)*6+(temps-1),1,3);
                    elseif(maxb==2)
                        tempb_add = movieideas_m{s3}((y-1)*6+(temps-1),1,2);
                        tempt_add = movieideas_m{s3}((y-1)*6+(temps-1),1,1);
                        tempc_add = movieideas_m{s3}((y-1)*6+(temps-1),1,3);
                    else
                        tempb_add = movieideas_h{s3}((y-1)*6+(temps-1),1,2);
                        tempt_add = movieideas_h{s3}((y-1)*6+(temps-1),1,1);
                        tempc_add = movieideas_h{s3}((y-1)*6+(temps-1),1,3);
                    end
                    
                    taddchars = [tempb_add; tempt_add; tempc_add; temps; maxb];
                    
                    tempde_add = squeeze(dshocks_cf{s3}(:,tempc_add,:))';
                    tempqe_add = qshocks_cf{s3}(:,tempc_add)';
                    %tempwme_add = squeeze(twmshocks_cf(:,tempc_add,:))';
                    tempwme_add = squeeze(twmshocks_cf(:,tempc_add,:));
                    
                    %The original code had line 782 commented and line 781
                    %active. This transposes a vector that should not be
                    %transposed, and the code does not work. Our detective
                    %work seems to show that our changes to the number of
                    %shocks is not behind this issue. %OUR CHANGE
                    
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = addmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},taddchars,maxw,tempde_add,tempqe_add,tempwme_add,params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                                                                                                                                                    
                    %Take added movie off the list of ideas
                    %Change number of movies of each type
                    if(maxb==1)
                        movieideas_l{s3}((y-1)*6+(temps-1),:,:)=[movieideas_l{s3}((y-1)*6+(temps-1),2:end,:) zeros(1,1,3)];
                        nmovies_lb_cf{s3}(y,temps)=nmovies_lb_cf{s3}(y,temps)+1;
                    elseif(maxb==2)
                        movieideas_m{s3}((y-1)*6+(temps-1),:,:)=[movieideas_m{s3}((y-1)*6+(temps-1),2:end,:) zeros(1,1,3)];
                        nmovies_mb_cf{s3}(y,temps)=nmovies_mb_cf{s3}(y,temps)+1;
                    else
                        movieideas_h{s3}((y-1)*6+(temps-1),:,:)=[movieideas_h{s3}((y-1)*6+(temps-1),2:end,:) zeros(1,1,3)];
                        nmovies_hb_cf{s3}(y,temps)=nmovies_hb_cf{s3}(y,temps)+1;
                    end
                    nmovies_all_cf{s3}(y,temps) = nmovies_all_cf{s3}(y,temps)+1;
                    
                    %Now give other films a chance to move around
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = weekadjust(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,xshocks_cf{s3},dshocks_cf{s3},qshocks_cf{s3},twmshocks_cf,[nshocks1;nshocks2;s3]);
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    
                else
                    aflag = 0;
                end
                
            end
            
            if(nlb_old == nmovies_lb_cf{s3}(y,:) & nmb_old == nmovies_mb_cf{s3}(y,:) & nhb_old == nmovies_hb_cf{s3}(y,:))
                eq=0;
            else
                eq=1;
            end
            
        end
        
        r = find(data_cf{s3}(:,1)==y+2008);
        year_delim_cf{s3}(y,2)=max(r);
        year_delim_cf{s3}(y+1,1)=max(r)+1;
        
        ytitles = data_cf{s3}(data_cf{s3}(:,1)==(y+2008) & data_cf{s3}(:,7)==1,3);
        rtitles = find(ismember(data_cf{s3}(:,3),ytitles));
        gross_compare_cf{s3}(gclimit(s3):gclimit(s3)+length(rtitles)-1,:)=[data_cf{s3}(rtitles,1:3) data_cf{s3}(rtitles,7) data_cf{s3}(rtitles,9)];
        gclimit(s3)=gclimit(s3)+length(rtitles);
        
    end

    r = find(data_cf{s3}(:,1)==11+2008);
    year_delim_cf{s3}(11,2)=max(r);
    
    ytitles = data_cf{s3}(data_cf{s3}(:,1)==(11+2008) & data_cf{s3}(:,7)==1,3);
    rtitles = find(ismember(data_cf{s3}(:,3),ytitles));
    gross_compare_cf{s3}(gclimit(s3):gclimit(s3)+length(rtitles)-1,:)=[data_cf{s3}(rtitles,1:3) data_cf{s3}(rtitles,7) data_cf{s3}(rtitles,9)];
    
    gross_comp_cf{s3} = zeros(length(data_cf{s3}),1);
    for i=1:length(data_cf{s3})
        r = find(gross_compare_cf{s3}(:,1)==data_cf{s3}(i,1) & gross_compare_cf{s3}(:,2)==data_cf{s3}(i,2) & gross_compare_cf{s3}(:,3)==data_cf{s3}(i,3) & gross_compare_cf{s3}(:,4)==data_cf{s3}(i,7));
        gross_comp_cf{s3}(i) = gross_compare_cf{s3}(r,5);
    end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Results Tables
%%%%%%%%%%%%%%%%%%%%%%%%%%

totallb = sum(nmovies_lb,2);
totalmb = sum(nmovies_mb,2);
totalhb = sum(nmovies_hb,2);
total = sum(nmovies_all,2);

totallb_cf = zeros(10,nshocks3);
totalmb_cf = zeros(10,nshocks3);
totalhb_cf = zeros(10,nshocks3);
total_cf = zeros(10,nshocks3);

for n=1:nshocks3
    totallb_cf(:,n) = sum(nmovies_lb_cf{n},2);
    totalmb_cf(:,n) = sum(nmovies_mb_cf{n},2);
    totalhb_cf(:,n) = sum(nmovies_hb_cf{n},2);
    total_cf(:,n) = sum(nmovies_all_cf{n},2); 
end

%Number of Movies
[sum(total) mean(sum(total_cf)) mean(sum(total_cf))-sum(total)...
    sum(totallb) mean(sum(totallb_cf)) mean(sum(totallb_cf))-sum(totallb)...
    sum(totalmb) mean(sum(totalmb_cf)) mean(sum(totalmb_cf))-sum(totalmb)...
    sum(totalhb) mean(sum(totalhb_cf)) mean(sum(totalhb_cf))-sum(totalhb)]

[sum(total) mean(sum(total_cf)) mean(sum(total_cf))-sum(total)...
    sum(totallb) mean(sum(totallb_cf)) mean(sum(totallb_cf))-sum(totallb)...
    sum(totalmb) mean(sum(totalmb_cf)) mean(sum(totalmb_cf))-sum(totalmb)...
    sum(totalhb) mean(sum(totalhb_cf)) mean(sum(totalhb_cf))-sum(totalhb)]/10

ts = sum(total);
tsc = mean(sum(total_cf));

[sum(total)/ts mean(sum(total_cf))/tsc mean(sum(total_cf))/tsc-sum(total)/ts...
    sum(totallb)/ts mean(sum(totallb_cf))/tsc mean(sum(totallb_cf))/tsc-sum(totallb)/ts...
    sum(totalmb)/ts mean(sum(totalmb_cf))/tsc mean(sum(totalmb_cf))/tsc-sum(totalmb)/ts...
    sum(totalhb)/ts mean(sum(totalhb_cf))/tsc mean(sum(totalhb_cf))/tsc-sum(totalhb)/ts]

gross_lb = zeros(10,7);
gross_lb_cf = zeros(nshocks3,10,7);
gross_mb = zeros(10,7);
gross_mb_cf = zeros(nshocks3,10,7);
gross_hb = zeros(10,7);
gross_hb_cf = zeros(nshocks3,10,7);
budget_lb = zeros(10,7);
budget_lb_cf = zeros(nshocks3,10,7);
budget_mb = zeros(10,7);
budget_mb_cf = zeros(nshocks3,10,7);
budget_hb = zeros(10,7);
budget_hb_cf = zeros(nshocks3,10,7);
theta_lb = zeros(10,7);
theta_lb_cf = zeros(nshocks3,10,7);
theta_mb = zeros(10,7);
theta_mb_cf = zeros(nshocks3,10,7);
theta_hb = zeros(10,7);
theta_hb_cf = zeros(nshocks3,10,7);

for y=1:10
    for s=1:7
        ltitles = data(data(:,1)==(y+2008) & data(:,4)==s & data(:,5)==1 & data(:,7)==1,3);
        rl = find(ismember(data(:,3),ltitles));
        gross_lb(y,s) = sum(gross_comp(rl));
        rl2 = find(ismember(data(:,3),ltitles) & data(:,7)==1);
        budget_lb(y,s) = sum(data(rl2,8));
        theta_lb(y,s) = sum(data(rl2,6));
        mtitles = data(data(:,1)==(y+2008) & data(:,4)==s & data(:,5)==2 & data(:,7)==1,3);
        rm = find(ismember(data(:,3),mtitles));
        gross_mb(y,s) = sum(gross_comp(rm));
        rm2 = find(ismember(data(:,3),mtitles) & data(:,7)==1);
        budget_mb(y,s) = sum(data(rm2,8));
        theta_mb(y,s) = sum(data(rm2,6));
        htitles = data(data(:,1)==(y+2008) & data(:,4)==s & data(:,5)==3 & data(:,7)==1,3);
        rh = find(ismember(data(:,3),htitles));
        gross_hb(y,s) = sum(gross_comp(rh));
        rh2 = find(ismember(data(:,3),htitles) & data(:,7)==1);
        budget_hb(y,s) = sum(data(rh2,8));
        theta_hb(y,s) = sum(data(rh2,6));
        
        for n=1:nshocks3
            ltitles = data_cf{n}(data_cf{n}(:,1)==(y+2008) & data_cf{n}(:,4)==s & data_cf{n}(:,5)==1 & data_cf{n}(:,7)==1,3);
            rl = find(ismember(data_cf{n}(:,3),ltitles));
            gross_lb_cf(n,y,s) = sum(gross_comp_cf{n}(rl));
            rl2 = find(ismember(data_cf{n}(:,3),ltitles) & data_cf{n}(:,7)==1);
            budget_lb_cf(n,y,s) = sum(data_cf{n}(rl2,8));
            theta_lb_cf(n,y,s) = sum(data_cf{n}(rl2,6));
            mtitles = data_cf{n}(data_cf{n}(:,1)==(y+2008) & data_cf{n}(:,4)==s & data_cf{n}(:,5)==2 & data_cf{n}(:,7)==1,3);
            rm = find(ismember(data_cf{n}(:,3),mtitles));
            gross_mb_cf(n,y,s) = sum(gross_comp_cf{n}(rm));
            rm2 = find(ismember(data_cf{n}(:,3),mtitles) & data_cf{n}(:,7)==1);
            budget_mb_cf(n,y,s) = sum(data_cf{n}(rm2,8));
            theta_mb_cf(n,y,s) = sum(data_cf{n}(rm2,6));
            htitles = data_cf{n}(data_cf{n}(:,1)==(y+2008) & data_cf{n}(:,4)==s & data_cf{n}(:,5)==3 & data_cf{n}(:,7)==1,3);
            rh = find(ismember(data_cf{n}(:,3),htitles));
            gross_hb_cf(n,y,s) = sum(gross_comp_cf{n}(rh));
            rh2 = find(ismember(data_cf{n}(:,3),htitles) & data_cf{n}(:,7)==1);
            budget_hb_cf(n,y,s) = sum(data_cf{n}(rh2,8));
            theta_hb_cf(n,y,s) = sum(data_cf{n}(rh2,6));
        end
    end
end

budgetlb = sum(budget_lb,2);
budgetmb = sum(budget_mb,2);
budgethb = sum(budget_hb,2);
budget = budgetlb+budgetmb+budgethb;

grosslb = sum(gross_lb,2);
grossmb = sum(gross_mb,2);
grosshb = sum(gross_hb,2);
gross = grosslb+grossmb+grosshb;

budgetlb_cf = zeros(10,nshocks3);
budgetmb_cf = zeros(10,nshocks3);
budgethb_cf = zeros(10,nshocks3);
budget_cf = zeros(10,nshocks3);

grosslb_cf = zeros(10,nshocks3);
grossmb_cf = zeros(10,nshocks3);
grosshb_cf = zeros(10,nshocks3);
gross_cf = zeros(10,nshocks3);

for n=1:nshocks3
    budgetlb_cf(:,n) = squeeze(sum(budget_lb_cf(n,:,:),3));
    budgetmb_cf(:,n) = squeeze(sum(budget_mb_cf(n,:,:),3));
    budgethb_cf(:,n) = squeeze(sum(budget_hb_cf(n,:,:),3));
    
    budget_cf(:,n) = budgetlb_cf(:,n)+budgetmb_cf(:,n)+budgethb_cf(:,n);
    
    grosslb_cf(:,n) = squeeze(sum(gross_lb_cf(n,:,:),3));
    grossmb_cf(:,n) = squeeze(sum(gross_mb_cf(n,:,:),3));
    grosshb_cf(:,n) = squeeze(sum(gross_hb_cf(n,:,:),3));
    
    gross_cf(:,n) = grosslb_cf(:,n)+grossmb_cf(:,n)+grosshb_cf(:,n);
end

%Percentage of Budget
tb = sum(budget);
tbc = mean(sum(budget_cf));

[sum(budget)/tb mean(sum(budget_cf))/tbc mean(sum(budget_cf))/tbc-sum(budget)/tb...
    sum(budgetlb)/tb mean(sum(budgetlb_cf))/tbc mean(sum(budgetlb_cf))/tbc-sum(budgetlb)/tb...
    sum(budgetmb)/tb mean(sum(budgetmb_cf))/tbc mean(sum(budgetmb_cf))/tbc-sum(budgetmb)/tb...
    sum(budgethb)/tb mean(sum(budgethb_cf))/tbc mean(sum(budgethb_cf))/tbc-sum(budgethb)/tb]

%Percentage of Gross
tg = sum(gross);
tgc = mean(sum(gross_cf));

[sum(gross)/tg mean(sum(gross_cf))/tgc mean(sum(gross_cf))/tgc-sum(gross)/tg...
    sum(grosslb)/tg mean(sum(grosslb_cf))/tgc mean(sum(grosslb_cf))/tgc-sum(grosslb)/tg...
    sum(grossmb)/tg mean(sum(grossmb_cf))/tgc mean(sum(grossmb_cf))/tgc-sum(grossmb)/tg...
    sum(grosshb)/tg mean(sum(grosshb_cf))/tgc mean(sum(grosshb_cf))/tgc-sum(grosshb)/tg]