%clear
%load('cf_nothing_sim.mat')

data = data_cf;
xvars = xvars_cf;
xshocks = xshocks_cf;
market_delim = market_delim_cf;
year_delim = year_delim_cf;

% OUR CHANGE
%CF: Multiply Netflix subscribers by 3 for all periods.
for n=1:nshocks3
    xvars_cf{n}(:,4) = 3*xvars{n}(:,4);
end
mnqsubscribers(1:end) = 3*xvars(:,4);

dshocks = dshocks_cf;
qshocks = qshocks_cf;
wmshocks = wmshocks_cf;

twmshocks = twmshocks_cf;

%Use to compare to observed (before adjust future years)
gross_compare = gross_compare_cf;
gross_comp = gross_comp_cf;
gross_compare_cf = repmat({zeros(5,5)},nshocks3,1);
gclimit=ones(nshocks3,1);

nmovies_lb = nmovies_lb_cf;
nmovies_mb = nmovies_mb_cf;
nmovies_hb = nmovies_hb_cf;
nmovies_all = nmovies_all_cf;

mintheta_lb = mintheta_lb_cf;
mintheta_mb = mintheta_mb_cf;
mintheta_hb = mintheta_hb_cf;

minbudget_lb = minbudget_lb_cf;
minbudget_mb = minbudget_mb_cf;
minbudget_hb = minbudget_hb_cf;

for s3 = 1:nshocks3
%for s3 = 1:1
    s3
    
    txcol = nshocks1+nshocks2+s3;
    
    for m=1:length(market_delim_cf{s3})
        mstart = market_delim_cf{s3}(m,1);
        mend = market_delim_cf{s3}(m,2);
        temp = [mstart:mend];
        data_cf{s3}(temp,9) = expectedrevenue(xvars_cf{s3}(temp,2:plength),params,[marketchars(m,1); marketchars(m,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,txcol));
    end
    
    for y=1:10
        y
        tempy = y+2008;

        [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = weekadjust(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,xshocks_cf{s3},dshocks_cf{s3},qshocks_cf{s3},twmshocks_cf,[nshocks1;nshocks2;s3]);
        
        eq = 1;
        
        while(eq)
            
            nlb_old = nmovies_lb_cf{s3}(y,:);
            nmb_old = nmovies_mb_cf{s3}(y,:);
            nhb_old = nmovies_hb_cf{s3}(y,:);
            
            dflag = 1;
            while(dflag)
                %Allow each studio to drop unprofitable movies
                tempdiff = zeros(6,3);
                tempdrop_all = zeros(6,3);
                for s=2:7
                    %Find all the movies made by that studio and drop the ones that have profit less than the fixed cost
                    rall = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    tempsmovies = data_cf{s3}(rall,3);
                    
                    maxbudget = nmovies_lb_cf{s3}(y,s)*maxb_all(1)+nmovies_mb_cf{s3}(y,s)*maxb_all(2)+nmovies_hb_cf{s3}(y,s)*maxb_all(3);
                    
                    ydec = zeros(3,1);
                    if(nmovies_lb_cf{s3}(y,s)>0 && tbudget(y,s-1)<(maxbudget-maxb_all(1)))
                        ydec(1)=1;
                    end
                    if(nmovies_mb_cf{s3}(y,s)>0 && tbudget(y,s-1)<(maxbudget-maxb_all(2)))
                        ydec(2)=1;
                    end
                    if(nmovies_hb_cf{s3}(y,s)>0 && tbudget(y,s-1)<(maxbudget-maxb_all(3)))
                        ydec(3)=1;
                    end
                    
                    rl = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==1 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rm = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==2 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rh = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==3 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    
                    %Low Budget
                    if(ydec(1))
                        r = rl;
                        templmovies = data_cf{s3}(r,3);
                        temptheta = data_cf{s3}(r,6);
                        tempchange_all = zeros(nmovies_lb_cf{s3}(y,s),2);
                        for j=1:nmovies_lb_cf{s3}(y,s)
                            tempdrop = templmovies(j);
                            tempchange_all(j,2)=tempdrop;
                            
                            if(nmovies_all_cf{s3}(y,s)>1)
                                [data_temp xvars_temp xshocks_temp market_delim_temp] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,s,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                
                                tempchange_all(j,1) = sum(data_temp(data_temp(:,4)==s,9))-sum(data_cf{s3}(data_cf{s3}(:,4)==s,9));
                                
                            else
                                r2 = find(data_cf{s3}(:,3)==tempdrop);
                                temprev = sum(data_cf{s3}(r2,9));
                                tempchange_all(j,1) = -temprev+data_cf{s3}(r(j),8);
                            end

                        end
                        
                        [minl minlow] = max(tempchange_all(:,1));
                        tempdiff(s-1,1) = minl+fc_lb(y,s);
                        tempdrop_all(s-1,1) = tempchange_all(minlow,2);
                        
                    else
                        tempdiff(s-1,1)=-1; %Not profitable to drop movie if no movies
                    end
                    
                    %Medium Budget
                    if(ydec(2))
                        r = rm;
                        tempmmovies = data_cf{s3}(r,3);
                        temptheta = data_cf{s3}(r,6);
                        tempchange_all = zeros(nmovies_mb_cf{s3}(y,s),2);
                        for j=1:nmovies_mb_cf{s3}(y,s)
                            tempdrop = tempmmovies(j);
                            tempchange_all(j,2)=tempdrop;
                            
                            if(nmovies_all_cf{s3}(y,s)>1)
                                [data_temp xvars_temp xshocks_temp market_delim_temp] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,s,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                
                                tempchange_all(j,1) = sum(data_temp(data_temp(:,4)==s,9))-sum(data_cf{s3}(data_cf{s3}(:,4)==s,9));
                                
                            else
                                r2 = find(data_cf{s3}(:,3)==tempdrop);
                                temprev = sum(data_cf{s3}(r2,9));
                                tempchange_all(j,1) = -temprev+data_cf{s3}(r(j),8);
                            end
                            
                        end
                        
                        [minl minlow] = max(tempchange_all(:,1));
                        tempdiff(s-1,2) = minl+fc_mb(y,s);
                        tempdrop_all(s-1,2) = tempchange_all(minlow,2);
                        
                    else
                        tempdiff(s-1,2)=-1; %Not profitable to drop movie if no movies
                    end
                    
                    %High Budget
                    if(ydec(3))
                        r = rh;
                        temphmovies = data_cf{s3}(r,3);
                        temptheta = data_cf{s3}(r,6);
                        tempchange_all = zeros(nmovies_hb_cf{s3}(y,s),2);
                        for j=1:nmovies_hb_cf{s3}(y,s)
                            tempdrop = temphmovies(j);
                            tempchange_all(j,2)=tempdrop;
                            
                            if(nmovies_all_cf{s3}(y,s)>1)
                                [data_temp xvars_temp xshocks_temp market_delim_temp] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,s,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                
                                tempchange_all(j,1) = sum(data_temp(data_temp(:,4)==s,9))-sum(data_cf{s3}(data_cf{s3}(:,4)==s,9));
                                
                            else
                                r2 = find(data_cf{s3}(:,3)==tempdrop);
                                temprev = sum(data_cf{s3}(r2,9));
                                tempchange_all(j,1) = -temprev+data_cf{s3}(r(j),8);
                            end

                        end
                        
                        [minl minlow] = max(tempchange_all(:,1));
                        tempdiff(s-1,3) = minl+fc_hb(y,s);
                        tempdrop_all(s-1,3) = tempchange_all(minlow,2);
                        
                    else
                        tempdiff(s-1,3)=-1; %Not profitable to drop movie if no movies
                    end
                    
                end
                
                [maxvf maxr] = max(tempdiff);
                [maxv maxb] = max(maxvf);
                maxs = maxr(maxb);
                
                %maxs is studio with max value
                %maxb is budget type with max value
                %maxv is max value
                
                if(maxv>0) %If dropping any movie increases profit
                    temps = maxs+1;
                    tempn = nmovies_all_cf{s3}(y,temps);
                    tempdrop = tempdrop_all(maxs,maxb);
                    r3 = find(data_cf{s3}(:,3)==tempdrop);
                    tempb = data_cf{s3}(r3(1),8);
                    tempt = data_cf{s3}(r3(1),6);
                    tempc = data_cf{s3}(r3(1),3);
                    
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = dropmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},tempdrop,temps,params,tempy,marketid,marketchars,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                    
                    %Add dropped movie to list of ideas
                    %Change number of movies of each type
                    if(maxb==1)
                        nmovies_lb_cf{s3}(y,temps)=nmovies_lb_cf{s3}(y,temps)-1;
                        movieideas_l{s3}((y-1)*6+(temps-1),2:end+1,:)=squeeze(movieideas_l{s3}((y-1)*6+(temps-1),:,:));
                        movieideas_l{s3}((y-1)*6+(temps-1),1,:)=[tempt tempb tempc];
                    elseif(maxb==2)
                        nmovies_mb_cf{s3}(y,temps)=nmovies_mb_cf{s3}(y,temps)-1;
                        movieideas_m{s3}((y-1)*6+(temps-1),2:end+1,:)=squeeze(movieideas_m{s3}((y-1)*6+(temps-1),:,:));
                        movieideas_m{s3}((y-1)*6+(temps-1),1,:)=[tempt tempb tempc];
                    else
                        nmovies_hb_cf{s3}(y,temps)=nmovies_hb_cf{s3}(y,temps)-1;
                        movieideas_h{s3}((y-1)*6+(temps-1),2:end+1,:)=squeeze(movieideas_h{s3}((y-1)*6+(temps-1),:,:));
                        movieideas_h{s3}((y-1)*6+(temps-1),1,:)=[tempt tempb tempc];
                    end
                    nmovies_all_cf{s3}(y,temps) = nmovies_all_cf{s3}(y,temps)-1;
                    
                    %Now give other films a chance to move around
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = weekadjust(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,xshocks_cf{s3},dshocks_cf{s3},qshocks_cf{s3},twmshocks_cf,[nshocks1;nshocks2;s3]);
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    
                else
                    dflag=0;
                    
                end
                
            end
            
            
            aflag = 1;
            while(aflag)
                %Allow studios to add profitable movies
                tempdiff = zeros(6,3); %Holds change in profit for adding move
                tempaddweek = zeros(6,3); %Holds best week to release movie
                %temptotweeks = zeros(6,3); %Holds how long movie is held in theaters
                for s=2:7
                    %Create CF movie for studio and add like in fixedcostestimation
                    %If profit is above fixed cost than add movie
                    
                    minb = nmovies_lb_cf{s3}(y,s)*minb_all(1)+nmovies_mb_cf{s3}(y,s)*minb_all(2)+nmovies_hb_cf{s3}(y,s)*minb_all(3);
                    
                    %                 yadd = [(~isempty(movieideas_l{y,s-1}))*(tbudget(y,s-1)>=(minb+minb_all(1)));...
                    %                     (~isempty(movieideas_m{y,s-1}))*(tbudget(y,s-1)>=(minb+minb_all(2)));...
                    %                     (~isempty(movieideas_h{y,s-1}))*(tbudget(y,s-1)>=(minb+minb_all(3)))];
                    
                    yadd = [(movieideas_l{s3}((y-1)*6+(s-1),1,3)~=0); (movieideas_m{s3}((y-1)*6+(s-1),1,3)~=0); (movieideas_h{s3}((y-1)*6+(s-1),1,3)~=0)];
                    if(yadd(1))
                        if((tbudget(y,s-1)<(minb+movieideas_l{s3}((y-1)*6+(s-1),1,2))))
                            yadd(1)=0;
                        end
                    end
                    if(yadd(2))
                        if((tbudget(y,s-1)<(minb+movieideas_m{s3}((y-1)*6+(s-1),1,2))))
                            yadd(2)=0;
                        end
                    end
                    if(yadd(3))
                        if((tbudget(y,s-1)<(minb+movieideas_h{s3}((y-1)*6+(s-1),1,2))))
                            yadd(3)=0;
                        end
                    end
                    
                    rall = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    ball = sum(data_cf{s3}(rall,8));
                    rlow = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==1 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rmed = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==2 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    rhigh = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,5)==3 & data_cf{s3}(:,7)==1 & data_cf{s3}(:,4)==s);
                    
                    samprevenues_byrweek_l = zeros(weeksinyear(y),1);
                    %Low Budget
                    if(yadd(1))
                        tempb_l = movieideas_l{s3}((y-1)*6+(s-1),1,2);
                        tempt_l = movieideas_l{s3}((y-1)*6+(s-1),1,1);
                        tempxvars_l = xvars_cf{s3}(:,2:plength);
                        tempde_l = dshocks_cf{s3}(:,movieideas_l{s3}((y-1)*6+(s-1),1,3),:);
                        tempqe_l = qshocks_cf{s3}(:,movieideas_l{s3}((y-1)*6+(s-1),1,3));
                        tempwme_l = twmshocks_cf(:,movieideas_l{s3}((y-1)*6+(s-1),1,3),:);
                        
                        blow_temp = data_cf{s3}(rall,8)-(data_cf{s3}(rall,8)/ball)*tempb_l;
                        adjustf = 1;
                        while(adjustf==1)
                            adjustf=0;
                            ti = find(ismember(rall,rlow));
                            if(sum(blow_temp(ti)<0)~=0)
                                rt = find(blow_temp(ti)<0);
                                addback = min(data_cf{s3}(rall(ti(rt)),8),1000000)-blow_temp(ti(rt));
                                blow_temp(ti(rt)) = blow_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                blow_temp(rtno)=blow_temp(rtno)-(blow_temp(rtno)/sum(blow_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rmed));
                            if(sum(blow_temp(ti)<maxb_all(1))~=0)
                                rt = find(blow_temp(ti)<maxb_all(1));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(2))-blow_temp(ti(rt));
                                blow_temp(ti(rt)) = blow_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                blow_temp(rtno)=blow_temp(rtno)-(blow_temp(rtno)/sum(blow_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(blow_temp(ti)<maxb_all(2))~=0)
                                rt = find(blow_temp(ti)<maxb_all(2));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(3))-blow_temp(ti(rt));
                                blow_temp(ti(rt)) = blow_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                blow_temp(rtno)=blow_temp(rtno)-(blow_temp(rtno)/sum(blow_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                        end
                        
                        for k=1:length(rall)
                            tempxvars_l(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)=tempxvars_l(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)+budgetcoef(4-data_cf{s3}(rall(k),5))*(log(blow_temp(k))-log(data_cf{s3}(rall(k),8)));
                        end
                        
                        rall2 = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,4)==s);
                        r2f = find(ismember(data_cf{s3}(:,3),data_cf{s3}(rall2,3)));
                        [t ti] = unique((data_cf{s3}(r2f,1)-2000)*60+data_cf{s3}(r2f,2));
                        r2 = r2f(ti);
                        tempchange_l = zeros(length(r2),3);
                        for l=1:length(r2)
                            r = find(marketid(:,1)==data_cf{s3}(r2(l),1) & marketid(:,2)==data_cf{s3}(r2(l),2));
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            %tempms = findms_nest(params(2:plength),params(1),tempxvars_l(temp,:),zeros(tempn,1));
                            %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                            temprev = expectedrevenue(tempxvars_l(temp,:),params,[marketchars(r,1); marketchars(r,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,nshocks1+nshocks2+s3));
                            tempgross = data_cf{s3}(temp,9);
                            tempdist = (data_cf{s3}(temp,4)==s);
                            tempchange_l(l,1) = sum(temprev(tempdist)-tempgross(tempdist));
                            tempchange_l(l,2) = data_cf{s3}(r2(l),1);
                            tempchange_l(l,3) = data_cf{s3}(r2(l),2);
                        end
                        
                    else
                        tempchange_l = zeros(1,3);
                    end
                    
                    samprevenues_byrweek_m = zeros(weeksinyear(y),1);
                    %Medium Budget
                    if(yadd(2))
                        tempb_m = movieideas_m{s3}((y-1)*6+(s-1),1,2);
                        tempt_m = movieideas_m{s3}((y-1)*6+(s-1),1,1);
                        tempxvars_m = xvars_cf{s3}(:,2:plength);
                        tempde_m = dshocks_cf{s3}(:,movieideas_m{s3}((y-1)*6+(s-1),1,3),:);
                        tempqe_m = qshocks_cf{s3}(:,movieideas_m{s3}((y-1)*6+(s-1),1,3));
                        tempwme_m = wmshocks_cf{s3}(movieideas_m{s3}((y-1)*6+(s-1),1,3),:);
                        
                        bmed_temp = data_cf{s3}(rall,8)-(data_cf{s3}(rall,8)/ball)*tempb_m;
                        adjustf = 1;
                        while(adjustf==1)
                            adjustf=0;
                            ti = find(ismember(rall,rlow));
                            if(sum(bmed_temp(ti)<0)~=0)
                                rt = find(bmed_temp(ti)<0);
                                addback = min(data_cf{s3}(rall(ti(rt)),8),1000000)-bmed_temp(ti(rt));
                                bmed_temp(ti(rt)) = bmed_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bmed_temp(rtno)=bmed_temp(rtno)-(bmed_temp(rtno)/sum(bmed_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rmed));
                            if(sum(bmed_temp(ti)<maxb_all(1))~=0)
                                rt = find(bmed_temp(ti)<maxb_all(1));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(2))-bmed_temp(ti(rt));
                                bmed_temp(ti(rt)) = bmed_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bmed_temp(rtno)=bmed_temp(rtno)-(bmed_temp(rtno)/sum(bmed_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(bmed_temp(ti)<maxb_all(2))~=0)
                                rt = find(bmed_temp(ti)<maxb_all(2));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(3))-bmed_temp(ti(rt));
                                bmed_temp(ti(rt)) = bmed_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bmed_temp(rtno)=bmed_temp(rtno)-(bmed_temp(rtno)/sum(bmed_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                        end
                        
                        for k=1:length(rall)
                            tempxvars_m(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)=tempxvars_m(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)+budgetcoef(4-data_cf{s3}(rall(k),5))*(log(bmed_temp(k))-log(data_cf{s3}(rall(k),8)));
                        end
                        
                        rall2 = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,4)==s);
                        r2f = find(ismember(data_cf{s3}(:,3),data_cf{s3}(rall2,3)));
                        [t ti] = unique((data_cf{s3}(r2f,1)-2000)*60+data_cf{s3}(r2f,2));
                        r2 = r2f(ti);
                        tempchange_m = zeros(length(r2),3);
                        for l=1:length(r2)
                            r = find(marketid(:,1)==data_cf{s3}(r2(l),1) & marketid(:,2)==data_cf{s3}(r2(l),2));
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            %tempms = findms_nest(params(2:plength),params(1),tempxvars_m(temp,:),zeros(tempn,1));
                            %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                            temprev = expectedrevenue(tempxvars_m(temp,:),params,[marketchars(r,1); marketchars(r,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,nshocks1+nshocks2+s3));
                            tempgross = data_cf{s3}(temp,9);
                            tempdist = (data_cf{s3}(temp,4)==s);
                            tempchange_m(l,1) = sum(temprev(tempdist)-tempgross(tempdist));
                            tempchange_m(l,2) = data_cf{s3}(r2(l),1);
                            tempchange_m(l,3) = data_cf{s3}(r2(l),2);
                        end
                        
                    else
                        tempchange_m = zeros(1,3);
                    end
                    
                    samprevenues_byrweek_h = zeros(weeksinyear(y),1);
                    %High Budget
                    if(yadd(3))
                        tempb_h = movieideas_h{s3}((y-1)*6+(s-1),1,2);
                        tempt_h = movieideas_h{s3}((y-1)*6+(s-1),1,1);
                        tempxvars_h = xvars_cf{s3}(:,2:plength);
                        tempde_h = dshocks_cf{s3}(:,movieideas_h{s3}((y-1)*6+(s-1),1,3),:);
                        tempqe_h = qshocks_cf{s3}(:,movieideas_h{s3}((y-1)*6+(s-1),1,3));
                        tempwme_h = wmshocks_cf{s3}(movieideas_h{s3}((y-1)*6+(s-1),1,3),:);
                        
                        bhigh_temp = data_cf{s3}(rall,8)-(data_cf{s3}(rall,8)/ball)*tempb_h;
                        adjustf = 1;
                        while(adjustf==1)
                            adjustf=0;
                            ti = find(ismember(rall,rlow));
                            if(sum(bhigh_temp(ti)<0)~=0)
                                rt = find(bhigh_temp(ti)<0);
                                addback = min(data_cf{s3}(rall(ti(rt)),8),1000000)-bhigh_temp(ti(rt));
                                bhigh_temp(ti(rt)) = bhigh_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bhigh_temp(rtno)=bhigh_temp(rtno)-(bhigh_temp(rtno)/sum(bhigh_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(bhigh_temp(ti)<maxb_all(1))~=0)
                                rt = find(bhigh_temp(ti)<maxb_all(1));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(2))-bhigh_temp(ti(rt));
                                bhigh_temp(ti(rt)) = bhigh_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bhigh_temp(rtno)=bhigh_temp(rtno)-(bhigh_temp(rtno)/sum(bhigh_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                            ti = find(ismember(rall,rhigh));
                            if(sum(bhigh_temp(ti)<maxb_all(2))~=0)
                                rt = find(bhigh_temp(ti)<maxb_all(2));
                                addback = min(data_cf{s3}(rall(ti(rt)),8),minb_all(3))-bhigh_temp(ti(rt));
                                bhigh_temp(ti(rt)) = bhigh_temp(ti(rt))+addback;
                                decall = sum(addback);
                                rtno = [1:length(rall)]';
                                rtno(ti(rt))=[];
                                bhigh_temp(rtno)=bhigh_temp(rtno)-(bhigh_temp(rtno)/sum(bhigh_temp(rtno)))*sum(addback);
                                adjustf = 1;
                            end
                        end
                        
                        for k=1:length(rall)
                            tempxvars_h(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)=tempxvars_h(data_cf{s3}(:,3)==data_cf{s3}(rall(k),3),plength-1)+budgetcoef(4-data_cf{s3}(rall(k),5))*(log(bhigh_temp(k))-log(data_cf{s3}(rall(k),8)));
                        end
                        
                        rall2 = find(data_cf{s3}(:,1)==tempy & data_cf{s3}(:,4)==s);
                        r2f = find(ismember(data_cf{s3}(:,3),data_cf{s3}(rall2,3)));
                        [t ti] = unique((data_cf{s3}(r2f,1)-2000)*60+data_cf{s3}(r2f,2));
                        r2 = r2f(ti);
                        tempchange_h = zeros(length(r2),3);
                        for l=1:length(r2)
                            r = find(marketid(:,1)==data_cf{s3}(r2(l),1) & marketid(:,2)==data_cf{s3}(r2(l),2));
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            %tempms = findms_nest(params(2:plength),params(1),tempxvars_h(temp,:),zeros(tempn,1));
                            %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                            temprev = expectedrevenue(tempxvars_h(temp,:),params,[marketchars(r,1); marketchars(r,2)],xshocks_cf{s3}(temp,1:nshocks1),xshocks_cf{s3}(temp,nshocks1+1:nshocks1+nshocks2),xshocks_cf{s3}(temp,nshocks1+nshocks2+s3));
                            tempgross = data_cf{s3}(temp,9);
                            tempdist = (data_cf{s3}(temp,4)==s);
                            tempchange_h(l,1) = sum(temprev(tempdist)-tempgross(tempdist));
                            tempchange_h(l,2) = data_cf{s3}(r2(l),1);
                            tempchange_h(l,3) = data_cf{s3}(r2(l),2);
                        end
                        
                    else
                        tempchange_h = zeros(1,3);
                    end
                    
                    %totweeks = zeros(weeksinyear(y),3); %Holds the total weeks that the 3 movies stays released
                    
                    for w=1:weeksinyear(y)
                        tempw = posweeks(y,w);
                        temprevw = zeros(maxnumweeks,3); %Holds the weekly revene for each week the 3 movies play
                        tempweeks = zeros(maxnumweeks,3); %Holds the index of the week for each week the 3 movies play
                        %stillin = ones(3,1); %Equal to 1 if the movie is still playing
                        for k=1:maxnumweeks
                            if(w+k-1<weeksinyear(y)+1)
                                r = find(marketid(:,1)==tempy & marketid(:,2)==posweeks(y,w+k-1));
                                tempw=(tempy-2000)*60+posweeks(y,w+k-1);
                            elseif(tempy<2018)
                                r = find(marketid(:,1)==(tempy+1) & marketid(:,2)==posweeks(y+1,w+k-1-weeksinyear(y)));
                                tempw=(tempy+1-2000)*60+posweeks(y+1,w+k-1-weeksinyear(y));
                            else
                                r = find(marketid(:,1)==2019 & marketid(:,2)==(w+k-1-weeksinyear(y)));
                                tempw=(2019-2000)*60+(w+k-1-weeksinyear(y));
                            end
                            
                            mstart = market_delim_cf{s3}(r,1);
                            mend = market_delim_cf{s3}(r,2);
                            temp = [mstart:mend];
                            tempn = mend-mstart+1;
                            rd = find(data_cf{s3}(temp,4)==s);
                            
                            tempmqs = mnqsubscribers(r);
                            tempweek = zeros(1,56);
                            tempweek(1,marketid(r,2))=1;
                            tempyear = zeros(1,10);
                            tempyear(1,marketid(r,1)-2008)=1;
                            
                            tempgroup = data_cf{s3}(temp,5);
                            
                            if(yadd(1))
                                tempweeks(k,1)=tempw;
                                
                                tempxvars_new = [k k^2 tempmqs tempweek(:,2:56) tempyear(:,2:10) 1 tempt_l];
                                tempxvars = [tempxvars_l(temp,:); tempxvars_new];
                                temperrors = [xshocks_cf{s3}(temp,:); squeeze(tempde_l(:,1,w+k-1))' tempqe_l' tempwme_l(:,w)'];
                                
                                %tempms = findms_nest(params(2:plength),params(1),tempxvars,temperrors);
                                %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                                temprev = expectedrevenue(tempxvars,params,[population_m(r); ticketprice_m(r)],temperrors(:,1:nshocks1),temperrors(:,nshocks1+1:nshocks1+nshocks2),temperrors(:,txcol));
                                temprevw(k,1) = temprev(tempn+1)-(sum(data_cf{s3}(mstart+rd-1,9))-sum(temprev(rd)));
                                %if(temprev(tempn+1)<mingross)
                                %    stillin(1)=0;
                                %    totweeks(w,1)= k;
                                %end
                            else
                                temprevw(k,1)=0;
                            end
                            
                            if(yadd(2))
                                tempweeks(k,2)=tempw;
                                
                                tempxvars_new = [k k^2 tempmqs tempweek(:,2:56) tempyear(:,2:10) 1 tempt_m];
                                tempxvars = [tempxvars_m(temp,:); tempxvars_new];
                                temperrors = [xshocks_cf{s3}(temp,:); squeeze(tempde_m(:,1,w+k-1))' tempqe_m' tempwme_l(:,w)'];
                                
                                %tempms = findms_nest(params(2:plength),params(1),tempxvars,temperrors);
                                %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                                temprev = expectedrevenue(tempxvars,params,[population_m(r); ticketprice_m(r)],temperrors(:,1:nshocks1),temperrors(:,nshocks1+1:nshocks1+nshocks2),temperrors(:,txcol));
                                temprevw(k,2) = temprev(tempn+1)-(sum(data_cf{s3}(mstart+rd-1,9))-sum(temprev(rd)));
                                %if(temprev(tempn+1)<mingross)
                                %    stillin(2)=0;
                                %    totweeks(w,2)= k;
                                %end
                            else
                                temprevw(k,2)=0;
                            end
                            
                            if(yadd(3))
                                tempweeks(k,3)=tempw;
                                
                                tempxvars_new = [k k^2 tempmqs tempweek(:,2:56) tempyear(:,2:10) 1 tempt_h];
                                tempxvars = [tempxvars_h(temp,:); tempxvars_new];
                                temperrors = [xshocks_cf{s3}(temp,:); squeeze(tempde_h(:,1,w+k-1))' tempqe_h' tempwme_l(:,w)'];
                                
                                %tempms = findms_nest(params(2:plength),params(1),tempxvars,temperrors);
                                %temprev = tempms*marketchars(r,1)*marketchars(r,2);
                                temprev = expectedrevenue(tempxvars,params,[population_m(r); ticketprice_m(r)],temperrors(:,1:nshocks1),temperrors(:,nshocks1+1:nshocks1+nshocks2),temperrors(:,txcol));
                                temprevw(k,3) = temprev(tempn+1)-(sum(data_cf{s3}(mstart+rd-1,9))-sum(temprev(rd)));
                                %if(temprev(tempn+1)<mingross)
                                %    stillin(3)=0;
                                %    totweeks(w,3)= k;
                                %end
                            else
                                temprevw(k,3)=0;
                            end
                            
                        end
                        
                        otherrevchange = zeros(3,1);
                        templ = (tempchange_l(:,2)-2000)*60+tempchange_l(:,3);
                        otherrevchange(1) = sum(tempchange_l(~ismember(templ,tempweeks(:,1))));
                        tempm = (tempchange_m(:,2)-2000)*60+tempchange_m(:,3);
                        otherrevchange(2) = sum(tempchange_m(~ismember(tempm,tempweeks(:,2))));
                        temph = (tempchange_h(:,2)-2000)*60+tempchange_h(:,3);
                        otherrevchange(3) = sum(tempchange_h(~ismember(temph,tempweeks(:,3))));
                        
                        samprevenues_byrweek_l(w) = sum(temprevw(:,1))+otherrevchange(1);
                        samprevenues_byrweek_m(w) = sum(temprevw(:,2))+otherrevchange(2);
                        samprevenues_byrweek_h(w) = sum(temprevw(:,3))+otherrevchange(3);
                        
                        %totweeks(w,logical(stillin))=10;
                        
                    end
                    
                    [rev_l tempaddweek(s-1,1)] = max(samprevenues_byrweek_l);
                    [rev_m tempaddweek(s-1,2)] = max(samprevenues_byrweek_m);
                    [rev_h tempaddweek(s-1,3)] = max(samprevenues_byrweek_h);
                    
                    tempdiff(s-1,1) = rev_l-fc_lb(y,s)*(yadd(1));
                    tempdiff(s-1,2) = rev_m-fc_mb(y,s)*(yadd(2));
                    tempdiff(s-1,3) = rev_h-fc_hb(y,s)*(yadd(3));
                    
                    %temptotweeks(s-1,1) = totweeks(tempaddweek(s-1,1),1);
                    %temptotweeks(s-1,2) = totweeks(tempaddweek(s-1,2),2);
                    %temptotweeks(s-1,3) = totweeks(tempaddweek(s-1,3),3);
                    
                end
                
                [maxvf maxr] = max(tempdiff);
                [maxv maxb] = max(maxvf);
                maxs = maxr(maxb);
                maxw = tempaddweek(maxs,maxb);
                %maxw2 = temptotweeks(maxs,maxb);
                
                %maxs is studio with max value
                %maxb is budget type with max value
                %maxv is max value
                %maxw is release week for film to be added
                %maxw2 is number of weeks to release movie
                
                if(maxv>0) %If adding any movie increases profit
                    temps = maxs+1;
                    
                    if(maxb==1)
                        tempb_add = movieideas_l{s3}((y-1)*6+(temps-1),1,2);
                        tempt_add = movieideas_l{s3}((y-1)*6+(temps-1),1,1);
                        tempc_add = movieideas_l{s3}((y-1)*6+(temps-1),1,3);
                    elseif(maxb==2)
                        tempb_add = movieideas_m{s3}((y-1)*6+(temps-1),1,2);
                        tempt_add = movieideas_m{s3}((y-1)*6+(temps-1),1,1);
                        tempc_add = movieideas_m{s3}((y-1)*6+(temps-1),1,3);
                    else
                        tempb_add = movieideas_h{s3}((y-1)*6+(temps-1),1,2);
                        tempt_add = movieideas_h{s3}((y-1)*6+(temps-1),1,1);
                        tempc_add = movieideas_h{s3}((y-1)*6+(temps-1),1,3);
                    end
                    
                    taddchars = [tempb_add; tempt_add; tempc_add; temps; maxb];
                    
                    tempde_add = squeeze(dshocks_cf{s3}(:,tempc_add,:))';
                    tempqe_add = qshocks_cf{s3}(:,tempc_add)';
                    tempwme_add = squeeze(twmshocks_cf(:,tempc_add,:))';
                    %tempwme_add = squeeze(twmshocks_cf(:,tempc_add,:));
                    
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = addmovie(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},taddchars,maxw,tempde_add,tempqe_add,tempwme_add,params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,minb_all,maxb_all,budgetcoef,xshocks_cf{s3},[nshocks1;nshocks2;s3]);
                                                                                                                                                                    
                    %Take added movie off the list of ideas
                    %Change number of movies of each type
                    if(maxb==1)
                        movieideas_l{s3}((y-1)*6+(temps-1),:,:)=[movieideas_l{s3}((y-1)*6+(temps-1),2:end,:) zeros(1,1,3)];
                        nmovies_lb_cf{s3}(y,temps)=nmovies_lb_cf{s3}(y,temps)+1;
                    elseif(maxb==2)
                        movieideas_m{s3}((y-1)*6+(temps-1),:,:)=[movieideas_m{s3}((y-1)*6+(temps-1),2:end,:) zeros(1,1,3)];
                        nmovies_mb_cf{s3}(y,temps)=nmovies_mb_cf{s3}(y,temps)+1;
                    else
                        movieideas_h{s3}((y-1)*6+(temps-1),:,:)=[movieideas_h{s3}((y-1)*6+(temps-1),2:end,:) zeros(1,1,3)];
                        nmovies_hb_cf{s3}(y,temps)=nmovies_hb_cf{s3}(y,temps)+1;
                    end
                    nmovies_all_cf{s3}(y,temps) = nmovies_all_cf{s3}(y,temps)+1;
                    
                    %Now give other films a chance to move around
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    [data_cf{s3} xvars_cf{s3} xshocks_cf{s3} market_delim_cf{s3}] = weekadjust(data_cf{s3},xvars_cf{s3},market_delim_cf{s3},params,tempy,weeksinyear,posweeks,maxnumweeks,marketid,marketchars,mnqsubscribers,xshocks_cf{s3},dshocks_cf{s3},qshocks_cf{s3},twmshocks_cf,[nshocks1;nshocks2;s3]);
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    
                else
                    aflag = 0;
                end
                
            end
            
            if(nlb_old == nmovies_lb_cf{s3}(y,:) & nmb_old == nmovies_mb_cf{s3}(y,:) & nhb_old == nmovies_hb_cf{s3}(y,:))
                eq=0;
            else
                eq=1;
            end
            
        end
        
        r = find(data_cf{s3}(:,1)==y+2008);
        year_delim_cf{s3}(y,2)=max(r);
        year_delim_cf{s3}(y+1,1)=max(r)+1;
        
        ytitles = data_cf{s3}(data_cf{s3}(:,1)==(y+2008) & data_cf{s3}(:,7)==1,3);
        rtitles = find(ismember(data_cf{s3}(:,3),ytitles));
        gross_compare_cf{s3}(gclimit(s3):gclimit(s3)+length(rtitles)-1,:)=[data_cf{s3}(rtitles,1:3) data_cf{s3}(rtitles,7) data_cf{s3}(rtitles,9)];
        gclimit(s3)=gclimit(s3)+length(rtitles);
        
    end

    r = find(data_cf{s3}(:,1)==11+2008);
    year_delim_cf{s3}(11,2)=max(r);
    
    ytitles = data_cf{s3}(data_cf{s3}(:,1)==(11+2008) & data_cf{s3}(:,7)==1,3);
    rtitles = find(ismember(data_cf{s3}(:,3),ytitles));
    gross_compare_cf{s3}(gclimit(s3):gclimit(s3)+length(rtitles)-1,:)=[data_cf{s3}(rtitles,1:3) data_cf{s3}(rtitles,7) data_cf{s3}(rtitles,9)];
    
    gross_comp_cf{s3} = zeros(length(data_cf{s3}),1);
    for i=1:length(data_cf{s3})
        r = find(gross_compare_cf{s3}(:,1)==data_cf{s3}(i,1) & gross_compare_cf{s3}(:,2)==data_cf{s3}(i,2) & gross_compare_cf{s3}(:,3)==data_cf{s3}(i,3) & gross_compare_cf{s3}(:,4)==data_cf{s3}(i,7));
        gross_comp_cf{s3}(i) = gross_compare_cf{s3}(r,5);
    end

    save('cf_startbench_sim.mat')

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Results Tables
%%%%%%%%%%%%%%%%%%%%%%%%%%

totallb = zeros(10,nshocks3);
totalmb = zeros(10,nshocks3);
totalhb = zeros(10,nshocks3);
total = zeros(10,nshocks3);

totallb_cf = zeros(10,nshocks3);
totalmb_cf = zeros(10,nshocks3);
totalhb_cf = zeros(10,nshocks3);
total_cf = zeros(10,nshocks3);

for n=1:nshocks3
    totallb(:,n) = sum(nmovies_lb{n},2);
    totalmb(:,n) = sum(nmovies_mb{n},2);
    totalhb(:,n) = sum(nmovies_hb{n},2);
    total(:,n) = sum(nmovies_all{n},2); 
    
    totallb_cf(:,n) = sum(nmovies_lb_cf{n},2);
    totalmb_cf(:,n) = sum(nmovies_mb_cf{n},2);
    totalhb_cf(:,n) = sum(nmovies_hb_cf{n},2);
    total_cf(:,n) = sum(nmovies_all_cf{n},2); 
end

gross_lb = zeros(nshocks3,10,7);
gross_lb_cf = zeros(nshocks3,10,7);
gross_mb = zeros(nshocks3,10,7);
gross_mb_cf = zeros(nshocks3,10,7);
gross_hb = zeros(nshocks3,10,7);
gross_hb_cf = zeros(nshocks3,10,7);
budget_lb = zeros(nshocks3,10,7);
budget_lb_cf = zeros(nshocks3,10,7);
budget_mb = zeros(nshocks3,10,7);
budget_mb_cf = zeros(nshocks3,10,7);
budget_hb = zeros(nshocks3,10,7);
budget_hb_cf = zeros(nshocks3,10,7);
theta_lb = zeros(nshocks3,10,7);
theta_lb_cf = zeros(nshocks3,10,7);
theta_mb = zeros(nshocks3,10,7);
theta_mb_cf = zeros(nshocks3,10,7);
theta_hb = zeros(nshocks3,10,7);
theta_hb_cf = zeros(nshocks3,10,7);

for y=1:10
    for s=1:7
        for n=1:nshocks3
            ltitles = data{n}(data{n}(:,1)==(y+2008) & data{n}(:,4)==s & data{n}(:,5)==1 & data{n}(:,7)==1,3);
            rl = find(ismember(data{n}(:,3),ltitles));
            gross_lb(n,y,s) = sum(gross_comp{n}(rl));
            rl2 = find(ismember(data{n}(:,3),ltitles) & data{n}(:,7)==1);
            budget_lb(n,y,s) = sum(data{n}(rl2,8));
            theta_lb(n,y,s) = sum(data{n}(rl2,6));
            mtitles = data{n}(data{n}(:,1)==(y+2008) & data{n}(:,4)==s & data{n}(:,5)==2 & data{n}(:,7)==1,3);
            rm = find(ismember(data{n}(:,3),mtitles));
            gross_mb(n,y,s) = sum(gross_comp{n}(rm));
            rm2 = find(ismember(data{n}(:,3),mtitles) & data{n}(:,7)==1);
            budget_mb(n,y,s) = sum(data{n}(rm2,8));
            theta_mb(n,y,s) = sum(data{n}(rm2,6));
            htitles = data{n}(data{n}(:,1)==(y+2008) & data{n}(:,4)==s & data{n}(:,5)==3 & data{n}(:,7)==1,3);
            rh = find(ismember(data{n}(:,3),htitles));
            gross_hb(n,y,s) = sum(gross_comp{n}(rh));
            rh2 = find(ismember(data{n}(:,3),htitles) & data{n}(:,7)==1);
            budget_hb(n,y,s) = sum(data{n}(rh2,8));
            theta_hb(n,y,s) = sum(data{n}(rh2,6));
            
            ltitles = data_cf{n}(data_cf{n}(:,1)==(y+2008) & data_cf{n}(:,4)==s & data_cf{n}(:,5)==1 & data_cf{n}(:,7)==1,3);
            rl = find(ismember(data_cf{n}(:,3),ltitles));
            gross_lb_cf(n,y,s) = sum(gross_comp_cf{n}(rl));
            rl2 = find(ismember(data_cf{n}(:,3),ltitles) & data_cf{n}(:,7)==1);
            budget_lb_cf(n,y,s) = sum(data_cf{n}(rl2,8));
            theta_lb_cf(n,y,s) = sum(data_cf{n}(rl2,6));
            mtitles = data_cf{n}(data_cf{n}(:,1)==(y+2008) & data_cf{n}(:,4)==s & data_cf{n}(:,5)==2 & data_cf{n}(:,7)==1,3);
            rm = find(ismember(data_cf{n}(:,3),mtitles));
            gross_mb_cf(n,y,s) = sum(gross_comp_cf{n}(rm));
            rm2 = find(ismember(data_cf{n}(:,3),mtitles) & data_cf{n}(:,7)==1);
            budget_mb_cf(n,y,s) = sum(data_cf{n}(rm2,8));
            theta_mb_cf(n,y,s) = sum(data_cf{n}(rm2,6));
            htitles = data_cf{n}(data_cf{n}(:,1)==(y+2008) & data_cf{n}(:,4)==s & data_cf{n}(:,5)==3 & data_cf{n}(:,7)==1,3);
            rh = find(ismember(data_cf{n}(:,3),htitles));
            gross_hb_cf(n,y,s) = sum(gross_comp_cf{n}(rh));
            rh2 = find(ismember(data_cf{n}(:,3),htitles) & data_cf{n}(:,7)==1);
            budget_hb_cf(n,y,s) = sum(data_cf{n}(rh2,8));
            theta_hb_cf(n,y,s) = sum(data_cf{n}(rh2,6));
        end
    end
end

budgetlb = zeros(10,nshocks3);
budgetmb = zeros(10,nshocks3);
budgethb = zeros(10,nshocks3);
budget = zeros(10,nshocks3);

budgetlb_cf = zeros(10,nshocks3);
budgetmb_cf = zeros(10,nshocks3);
budgethb_cf = zeros(10,nshocks3);
budget_cf = zeros(10,nshocks3);

grosslb = zeros(10,nshocks3);
grossmb = zeros(10,nshocks3);
grosshb = zeros(10,nshocks3);
gross = zeros(10,nshocks3);

grosslb_cf = zeros(10,nshocks3);
grossmb_cf = zeros(10,nshocks3);
grosshb_cf = zeros(10,nshocks3);
gross_cf = zeros(10,nshocks3);

for n=1:nshocks3
    budgetlb(:,n) = squeeze(sum(budget_lb(n,:,:),3));
    budgetmb(:,n) = squeeze(sum(budget_mb(n,:,:),3));
    budgethb(:,n) = squeeze(sum(budget_hb(n,:,:),3));
    
    budget(:,n) = budgetlb(:,n)+budgetmb(:,n)+budgethb(:,n);
    
    grosslb(:,n) = squeeze(sum(gross_lb(n,:,:),3));
    grossmb(:,n) = squeeze(sum(gross_mb(n,:,:),3));
    grosshb(:,n) = squeeze(sum(gross_hb(n,:,:),3));
    
    gross(:,n) = grosslb(:,n)+grossmb(:,n)+grosshb(:,n);
    
    budgetlb_cf(:,n) = squeeze(sum(budget_lb_cf(n,:,:),3));
    budgetmb_cf(:,n) = squeeze(sum(budget_mb_cf(n,:,:),3));
    budgethb_cf(:,n) = squeeze(sum(budget_hb_cf(n,:,:),3));
    
    budget_cf(:,n) = budgetlb_cf(:,n)+budgetmb_cf(:,n)+budgethb_cf(:,n);
    
    grosslb_cf(:,n) = squeeze(sum(gross_lb_cf(n,:,:),3));
    grossmb_cf(:,n) = squeeze(sum(gross_mb_cf(n,:,:),3));
    grosshb_cf(:,n) = squeeze(sum(gross_hb_cf(n,:,:),3));
    
    gross_cf(:,n) = grosslb_cf(:,n)+grossmb_cf(:,n)+grosshb_cf(:,n);
end


%Output

% # Movies
[mean(sum(total)) mean(sum(total_cf)) mean(sum(total_cf)-sum(total))...
    mean(sum(totallb)) mean(sum(totallb_cf)) mean(sum(totallb_cf)-sum(totallb))...
    mean(sum(totalmb)) mean(sum(totalmb_cf)) mean(sum(totalmb_cf)-sum(totalmb))...
    mean(sum(totalhb)) mean(sum(totalhb_cf)) mean(sum(totalhb_cf)-sum(totalhb))]

[min(sum(total)) min(sum(total_cf)) min(sum(total_cf)-sum(total))...
    min(sum(totallb)) min(sum(totallb_cf)) min(sum(totallb_cf)-sum(totallb))...
    min(sum(totalmb)) min(sum(totalmb_cf)) min(sum(totalmb_cf)-sum(totalmb))...
    min(sum(totalhb)) min(sum(totalhb_cf)) min(sum(totalhb_cf)-sum(totalhb))]

[max(sum(total)) max(sum(total_cf)) max(sum(total_cf)-sum(total))...
    max(sum(totallb)) max(sum(totallb_cf)) max(sum(totallb_cf)-sum(totallb))...
    max(sum(totalmb)) max(sum(totalmb_cf)) max(sum(totalmb_cf)-sum(totalmb))...
    max(sum(totalhb)) max(sum(totalhb_cf)) max(sum(totalhb_cf)-sum(totalhb))]

% %Total Movies
[mean(sum(total)./sum(total)) mean(sum(total_cf)./sum(total_cf)) mean(sum(total_cf)./sum(total_cf)-sum(total)./sum(total))...
    mean(sum(totallb)./sum(total)) mean(sum(totallb_cf)./sum(total_cf)) mean(sum(totallb_cf)./sum(total_cf)-sum(totallb)./sum(total))...
    mean(sum(totalmb)./sum(total)) mean(sum(totalmb_cf)./sum(total_cf)) mean(sum(totalmb_cf)./sum(total_cf)-sum(totalmb)./sum(total))...
    mean(sum(totalhb)./sum(total)) mean(sum(totalhb_cf)./sum(total_cf)) mean(sum(totalhb_cf)./sum(total_cf)-sum(totalhb)./sum(total))]

[min(sum(total)./sum(total)) min(sum(total_cf)./sum(total_cf)) min(sum(total_cf)./sum(total_cf)-sum(total)./sum(total))...
    min(sum(totallb)./sum(total)) min(sum(totallb_cf)./sum(total_cf)) min(sum(totallb_cf)./sum(total_cf)-sum(totallb)./sum(total))...
    min(sum(totalmb)./sum(total)) min(sum(totalmb_cf)./sum(total_cf)) min(sum(totalmb_cf)./sum(total_cf)-sum(totalmb)./sum(total))...
    min(sum(totalhb)./sum(total)) min(sum(totalhb_cf)./sum(total_cf)) min(sum(totalhb_cf)./sum(total_cf)-sum(totalhb)./sum(total))]

[max(sum(total)./sum(total)) max(sum(total_cf)./sum(total_cf)) max(sum(total_cf)./sum(total_cf)-sum(total)./sum(total))...
    max(sum(totallb)./sum(total)) max(sum(totallb_cf)./sum(total_cf)) max(sum(totallb_cf)./sum(total_cf)-sum(totallb)./sum(total))...
    max(sum(totalmb)./sum(total)) max(sum(totalmb_cf)./sum(total_cf)) max(sum(totalmb_cf)./sum(total_cf)-sum(totalmb)./sum(total))...
    max(sum(totalhb)./sum(total)) max(sum(totalhb_cf)./sum(total_cf)) max(sum(totalhb_cf)./sum(total_cf)-sum(totalhb)./sum(total))]

%Percentage of Budget
[mean(sum(budget)./sum(budget)) mean(sum(budget_cf)./sum(budget_cf)) mean(sum(budget_cf)./sum(budget_cf)-sum(budget)./sum(budget))...
    mean(sum(budgetlb)./sum(budget)) mean(sum(budgetlb_cf)./sum(budget_cf)) mean(sum(budgetlb_cf)./sum(budget_cf)-sum(budgetlb)./sum(budget))...
    mean(sum(budgetmb)./sum(budget)) mean(sum(budgetmb_cf)./sum(budget_cf)) mean(sum(budgetmb_cf)./sum(budget_cf)-sum(budgetmb)./sum(budget))...
    mean(sum(budgethb)./sum(budget)) mean(sum(budgethb_cf)./sum(budget_cf)) mean(sum(budgethb_cf)./sum(budget_cf)-sum(budgethb)./sum(budget))]

[min(sum(budget)./sum(budget)) min(sum(budget_cf)./sum(budget_cf)) min(sum(budget_cf)./sum(budget_cf)-sum(budget)./sum(budget))...
    min(sum(budgetlb)./sum(budget)) min(sum(budgetlb_cf)./sum(budget_cf)) min(sum(budgetlb_cf)./sum(budget_cf)-sum(budgetlb)./sum(budget))...
    min(sum(budgetmb)./sum(budget)) min(sum(budgetmb_cf)./sum(budget_cf)) min(sum(budgetmb_cf)./sum(budget_cf)-sum(budgetmb)./sum(budget))...
    min(sum(budgethb)./sum(budget)) min(sum(budgethb_cf)./sum(budget_cf)) min(sum(budgethb_cf)./sum(budget_cf)-sum(budgethb)./sum(budget))]

[max(sum(budget)./sum(budget)) max(sum(budget_cf)./sum(budget_cf)) max(sum(budget_cf)./sum(budget_cf)-sum(budget)./sum(budget))...
    max(sum(budgetlb)./sum(budget)) max(sum(budgetlb_cf)./sum(budget_cf)) max(sum(budgetlb_cf)./sum(budget_cf)-sum(budgetlb)./sum(budget))...
    max(sum(budgetmb)./sum(budget)) max(sum(budgetmb_cf)./sum(budget_cf)) max(sum(budgetmb_cf)./sum(budget_cf)-sum(budgetmb)./sum(budget))...
    max(sum(budgethb)./sum(budget)) max(sum(budgethb_cf)./sum(budget_cf)) max(sum(budgethb_cf)./sum(budget_cf)-sum(budgethb)./sum(budget))]


%Percentage of Gross
[mean(sum(gross)./sum(gross)) mean(sum(gross_cf)./sum(gross_cf)) mean(sum(gross_cf)./sum(gross_cf)-sum(gross)./sum(gross))...
    mean(sum(grosslb)./sum(gross)) mean(sum(grosslb_cf)./sum(gross_cf)) mean(sum(grosslb_cf)./sum(gross_cf)-sum(grosslb)./sum(gross))...
    mean(sum(grossmb)./sum(gross)) mean(sum(grossmb_cf)./sum(gross_cf)) mean(sum(grossmb_cf)./sum(gross_cf)-sum(grossmb)./sum(gross))...
    mean(sum(grosshb)./sum(gross)) mean(sum(grosshb_cf)./sum(gross_cf)) mean(sum(grosshb_cf)./sum(gross_cf)-sum(grosshb)./sum(gross))]

[min(sum(gross)./sum(gross)) min(sum(gross_cf)./sum(gross_cf)) min(sum(gross_cf)./sum(gross_cf)-sum(gross)./sum(gross))...
    min(sum(grosslb)./sum(gross)) min(sum(grosslb_cf)./sum(gross_cf)) min(sum(grosslb_cf)./sum(gross_cf)-sum(grosslb)./sum(gross))...
    min(sum(grossmb)./sum(gross)) min(sum(grossmb_cf)./sum(gross_cf)) min(sum(grossmb_cf)./sum(gross_cf)-sum(grossmb)./sum(gross))...
    min(sum(grosshb)./sum(gross)) min(sum(grosshb_cf)./sum(gross_cf)) min(sum(grosshb_cf)./sum(gross_cf)-sum(grosshb)./sum(gross))]

[max(sum(gross)./sum(gross)) max(sum(gross_cf)./sum(gross_cf)) max(sum(gross_cf)./sum(gross_cf)-sum(gross)./sum(gross))...
    max(sum(grosslb)./sum(gross)) max(sum(grosslb_cf)./sum(gross_cf)) max(sum(grosslb_cf)./sum(gross_cf)-sum(grosslb)./sum(gross))...
    max(sum(grossmb)./sum(gross)) max(sum(grossmb_cf)./sum(gross_cf)) max(sum(grossmb_cf)./sum(gross_cf)-sum(grossmb)./sum(gross))...
    max(sum(grosshb)./sum(gross)) max(sum(grosshb_cf)./sum(gross_cf)) max(sum(grosshb_cf)./sum(gross_cf)-sum(grosshb)./sum(gross))]


